EXPORT	chunky_to_independent	; transform a 8 bit image without planes (like PC format) to vdi independent mode


TEXT

prepare_chunky_to_independent:
	movem.l d0-d7/a0-a6,-(sp)

	move.w	#1,bit_to_plane_ok					; flag to indicate that table os created.

	lea.l	bit_to_plane,a0
	move.w	#$8000,d0	; first pattern
	moveq.l	#16-1,d1	; 16 tabs of 4096 bytes each
	moveq.l	#0,d6
.boucle_tab:
	move.w	#256-1,d2
	moveq.l	#0,d3
.boucle_do_it:
	moveq.l	#8-1,d4
	move.w	d3,d5
.boucle_fill_it:
	lsr.w	#1,d5
	bcc.b	.bit_clear
.bit_set:
	move.w	d0,(a0)+
	dbra.w	d4,.boucle_fill_it
	addq.w	#1,d3
	dbra.w	d2,.boucle_do_it
	lsr.w	#1,d0
	dbra.w	d1,.boucle_tab

	movem.l	(sp)+,d0-d7/a0-a6
	rts
.bit_clear:
	move.w	d6,(a0)+
.ok_bit:
	dbra.w	d4,.boucle_fill_it
	addq.w	#1,d3
	dbra.w	d2,.boucle_do_it
	lsr.w	#1,d0
	dbra.w	d1,.boucle_tab

	movem.l	(sp)+,d0-d7/a0-a6
	rts


chunky_to_independent:
	movem.l d3-d7/a2-a6,-(sp)

	; a0: addr. picture in chunky format
	; a1: addr. picture in vdi independent format 
	; d0: number of points of the picture
	; d1: number of planes of the destination (1-8)
	; d2: size of one plane (size of destination / number of planes)

	tst.w	bit_to_plane_ok
	bne.b	.no_fill
	bsr.b prepare_chunky_to_independent
.no_fill:

	addq.l	#1,d0
	move.l	a1,a3

	lea.l	planes_routs,a2
	lsl.l	#2,d1
	move.l	(a2,d1.w),a4
	; move.l	(planes_routs,d1.w*4),a4 ; >= 68020 only !
	jsr	(a4)

	movem.l	(sp)+,d3-d7/a2-a6
	rts


convert_it_standard_8:
	move.l	a1,a4
	move.l	a3,a5
	move.l	a4,a6
	move.l	d2,d3
	lsl.l	#1,d3
	move.l	d3,d4
	lsl.l	#1,d4
	move.l	d4,d5
	add.l	d3,d5
	add.l	d3,a4
	add.l	d4,a5
	add.l	d5,a6
.boucle_all_pixels_8:
	lea.l	bit_to_plane-4096,a1
	moveq.l	#16-1,d3
	moveq.l	#0,d4
	moveq.l	#0,d5
	move.l	d4,d6
	move.l	d5,d7
.boucle_16_pixels_8:
	moveq.l	#0,d1
	move.b	(a0)+,d1
	lea.l	4096(a1),a1
	lsl.l	#4,d1
	lea.l	(a1,d1.l),a2
	subq.l	#1,d0
	beq.b	.quit_convert_8
	or.l	(a2)+,d4
	or.l	(a2)+,d5
	or.l	(a2)+,d6
	or.l	(a2)+,d7
	dbra.w	d3,.boucle_16_pixels_8
	move.w	d7,(a6,d2.l)
	move.w	d6,(a5,d2.l)
	swap	d7
	move.w	d5,(a4,d2.l)
	swap	d6
	move.w	d4,(a3,d2.l)
	swap	d5
	move.w	d7,(a6)
	swap	d4
	move.w	d6,(a5)
	move.w	d5,(a4)
	move.w	d4,(a3)
	addq.l	#2,a3
	addq.l	#2,a4
	addq.l	#2,a5
	addq.l	#2,a6
	bra.b	.boucle_all_pixels_8
.quit_convert_8:
	rts


convert_it_standard_7:
	move.l	a1,a4
	move.l	a3,a5
	move.l	a4,a6
	move.l	d2,d3
	lsl.l	#1,d3
	move.l	d3,d4
	lsl.l	#1,d4
	move.l	d4,d5
	add.l	d3,d5
	add.l	d3,a4
	add.l	d4,a5
	add.l	d5,a6
.boucle_all_pixels_7:
	lea.l	bit_to_plane-4096,a1
	moveq.l	#16-1,d3
	moveq.l	#0,d4
	moveq.l	#0,d5
	move.l	d4,d6
	move.w	d5,d7
.boucle_16_pixels_7:
	moveq.l	#0,d1
	move.b	(a0)+,d1
	lea.l	4096(a1),a1
	lsl.l	#4,d1
	lea.l	(a1,d1.l),a2
	subq.l	#1,d0
	beq.b	.quit_convert_7
	or.l	(a2)+,d4
	or.l	(a2)+,d5
	or.l	(a2)+,d6
	or.l	(a2)+,d7
	dbra.w	d3,.boucle_16_pixels_7
	move.w	d6,(a5,d2.l)
	swap	d7
	move.w	d5,(a4,d2.l)
	swap	d6
	move.w	d4,(a3,d2.l)
	swap	d5
	move.w	d7,(a6)
	swap	d4
	move.w	d6,(a5)
	move.w	d5,(a4)
	move.w	d4,(a3)
	addq.l	#2,a3
	addq.l	#2,a4
	addq.l	#2,a5
	addq.l	#2,a6
	bra.b	.boucle_all_pixels_7
.quit_convert_7:
	rts


convert_it_standard_6:
	move.l	a1,a4
	move.l	a3,a5
	move.l	a4,a6
	move.l	d2,d3
	lsl.l	#1,d3
	move.l	d3,d4
	lsl.l	#1,d4
	move.l	d4,d5
	add.l	d3,d5
	add.l	d3,a4
	add.l	d4,a5
.boucle_all_pixels_6:
	lea.l	bit_to_plane-4096,a1
	moveq.l	#16-1,d3
	moveq.l	#0,d4
	moveq.l	#0,d5
	move.l	d4,d6
.boucle_16_pixels_6:
	moveq.l	#0,d1
	move.b	(a0)+,d1
	lea.l	4096(a1),a1
	lsl.l	#4,d1
	lea.l	(a1,d1.l),a2
	subq.l	#1,d0
	beq.b	.quit_convert_6
	or.l	(a2)+,d4
	or.l	(a2)+,d5
	or.l	(a2)+,d6
	dbra.w	d3,.boucle_16_pixels_6
	move.w	d6,(a5,d2.l)
	move.w	d5,(a4,d2.l)
	swap	d6
	move.w	d4,(a3,d2.l)
	swap	d5
	swap	d4
	move.w	d6,(a5)
	move.w	d5,(a4)
	move.w	d4,(a3)
	addq.l	#2,a3
	addq.l	#2,a4
	addq.l	#2,a5
	bra.b	.boucle_all_pixels_6
.quit_convert_6:
	rts


convert_it_standard_5:
	move.l	a1,a4
	move.l	a3,a5
	move.l	a4,a6
	move.l	d2,d3
	lsl.l	#1,d3
	move.l	d3,d4
	lsl.l	#1,d4
	move.l	d4,d5
	add.l	d3,d5
	add.l	d3,a4
	add.l	d4,a5
.boucle_all_pixels_5:
	lea.l	bit_to_plane-4096,a1
	moveq.l	#16-1,d3
	moveq.l	#0,d4
	moveq.l	#0,d5
	move.l	d4,d6
.boucle_16_pixels_5:
	moveq.l	#0,d1
	move.b	(a0)+,d1
	lea.l	4096(a1),a1
	lsl.l	#4,d1
	lea.l	(a1,d1.l),a2
	subq.l	#1,d0
	beq.b	.quit_convert_5
	or.l	(a2)+,d4
	or.l	(a2)+,d5
	or.l	(a2)+,d6
	dbra.w	d3,.boucle_16_pixels_5
	move.w	d5,(a4,d2.l)
	swap	d6
	move.w	d4,(a3,d2.l)
	swap	d5
	swap	d4
	move.w	d6,(a5)
	move.w	d5,(a4)
	move.w	d4,(a3)
	addq.l	#2,a3
	addq.l	#2,a4
	addq.l	#2,a5
	bra.b	.boucle_all_pixels_5
.quit_convert_5:
	rts


convert_it_standard_4:
	move.l	a1,a4
	move.l	d2,d3
	lsl.l	#1,d3
	add.l	d3,a4
.boucle_all_pixels_4:
	lea.l	bit_to_plane-4096,a1
	moveq.l	#16-1,d3
	moveq.l	#0,d4
	moveq.l	#0,d5
	move.l	d4,d6
.boucle_16_pixels_4:
	moveq.l	#0,d1
	move.b	(a0)+,d1
	lea.l	4096(a1),a1
	lsl.l	#4,d1
	lea.l	(a1,d1.l),a2
	subq.l	#1,d0
	beq.b	.quit_convert_4
	or.l	(a2)+,d4
	or.l	(a2)+,d5
	dbra.w	d3,.boucle_16_pixels_4
	move.w	d5,(a4,d2.l)
	move.w	d4,(a3,d2.l)
	swap	d5
	swap	d4
	move.w	d5,(a4)
	move.w	d4,(a3)
	addq.l	#2,a3
	addq.l	#2,a4
	bra.b	.boucle_all_pixels_4
.quit_convert_4:
	rts


convert_it_standard_3:
	move.l	a1,a4
	move.l	d2,d3
	lsl.l	#1,d3
	add.l	d3,a4
.boucle_all_pixels_3:
	lea.l	bit_to_plane-4096,a1
	moveq.l	#16-1,d3
	moveq.l	#0,d4
	moveq.l	#0,d5
	move.l	d4,d6
.boucle_16_pixels_3:
	moveq.l	#0,d1
	move.b	(a0)+,d1
	lea.l	4096(a1),a1
	lsl.l	#4,d1
	lea.l	(a1,d1.l),a2
	subq.l	#1,d0
	beq.b	.quit_convert_3
	or.l	(a2)+,d4
	or.l	(a2)+,d5
	dbra.w	d3,.boucle_16_pixels_3
	move.w	d4,(a3,d2.l)
	swap	d5
	swap	d4
	move.w	d5,(a4)
	move.w	d4,(a3)
	addq.l	#2,a3
	addq.l	#2,a4
	bra.b	.boucle_all_pixels_3
.quit_convert_3:
	rts


convert_it_standard_2:
	move.l	a3,a4
	add.l	d2,a4
.boucle_all_pixels_2:
	lea.l	bit_to_plane-4096,a1
	moveq.l	#16-1,d3
	moveq.l	#0,d4
	moveq.l	#0,d5
	move.l	d4,d6
.boucle_16_pixels_2:
	moveq.l	#0,d1
	move.b	(a0)+,d1
	lea.l	4096(a1),a1
	lsl.l	#4,d1
	lea.l	(a1,d1.l),a2
	subq.l	#1,d0
	beq.b	.quit_convert_2
	or.l	(a2),d4
	dbra.w	d3,.boucle_16_pixels_2
	move.w	d4,(a4)
	swap	d4
	move.w	d4,(a3)
	addq.l	#2,a3
	addq.l	#2,a4
	bra.b	.boucle_all_pixels_2
.quit_convert_2:
	rts


convert_it_standard_1:
.boucle_all_pixels_1:
	lea.l	bit_to_plane-4096,a1
	moveq.l	#16-1,d3
	moveq.l	#0,d4
	moveq.l	#0,d5
	move.l	d4,d6
.boucle_16_pixels_1:
	moveq.l	#0,d1
	move.b	(a0)+,d1
	lea.l	4096(a1),a1
	lsl.l	#4,d1
	lea.l	(a1,d1.l),a2
	subq.l	#1,d0
	beq.b	.quit_convert_1
	or.w	(a2),d4
	dbra.w	d3,.boucle_16_pixels_1
	move.w	d4,(a3)
	addq.l	#2,a3
	bra.b	.boucle_all_pixels_1
.quit_convert_1:
	rts


convert_error:
	rts


DATA

bit_to_plane_ok:
	dc.w	0

planes_routs:
	dc.l	convert_error
	dc.l	convert_it_standard_1
	dc.l	convert_it_standard_2
	dc.l	convert_it_standard_3
	dc.l	convert_it_standard_4
	dc.l	convert_it_standard_5
	dc.l	convert_it_standard_6
	dc.l	convert_it_standard_7
	dc.l	convert_it_standard_8


BSS

bit_to_plane:
	ds.l	16384	; 64 kb.