#include	<ext.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>
#include	<math.h>
#include	<x_gem.h>
#include	"mypdf.h"
#include	"mypdf.rh"
#include	"files.h"
#include	"typespdf.h"
#include	"info_pdf.h"
#include	"status.h"
#include	"options.h"
#include	"mp_const.h"
#include	"memdebug.h"
#include	"av_comm.h"
#include	"filters.h"
#include	"cont_pat.h"
#include	"text_st.h"
#include	"graf_sta.h"
#include	"windinfo.h"


extern X_GEM_INFO *x_gem;


#define ULONG unsigned long

#define BEZIER_STEP	0.1

#define XYZ struct XYZ
XYZ
{
	long x, y, z;		/* it's long because vdi coordinates may be negative if a scroll is done */
};

/* Four control point Bezier interpolation
   mu ranges from 0 to 1, start to end of curve */
/* er: some changes to avoid stupid warnings ;) */
/* rk: new routine according to the PostScript description - but the effect is the same	*/

#define N 30000
#define PI	3.14
#define TWOPI	2*PI

int butterfly1(int argc,char **argv)
{
   int i;
   double u,r,p4,p8;
   XYZ p,plast;

   for (i=0;i<=N;i++) {
      u = i * 21.0 * PI / N;
      p4 = sin(17 * u / 3);
      p8 = sin(2 * cos(3 * u) - 28 * u);
      r = 5*(1 + sin(11*u/5)) - 4*p4*p4*p4*p4 * p8*p8*p8*p8*p8*p8*p8*p8;
      p.x = r * cos(u);
      p.y = r * sin(u);
      p.z = (r/20+.2)*sin(r*TWOPI/7);
      if (i > 0)
/*         --- write the line plast -> p in your favourite format ---	*/
      plast = p;
   }
	return(i);
}


int butterlfly2(int argc,char **argv)
{
   int i;
   double u;
   XYZ p,plast;

   for (i=0;i<N;i++) {
      u = i * 24.0 * PI / N;
      p.x = cos(u) * (exp(cos(u)) - 2 * cos(4 * u) - pow(sin(u / 12),5.0));
      p.y = sin(u) * (exp(cos(u)) - 2 * cos(4 * u) - pow(sin(u / 12),5.0));
      p.z = fabs(p.y) / 2;
   /*   colour = GetColour(u,0.0,24*PI,4);	*/
      if (i > 0) {
     /*    Do something with the line from plast to p	*/
      }
      plast = p;
   }
	return(i);
}



XYZ *Bezier3(XYZ *p1,XYZ *p2,XYZ *p3, double mu)
	{
   double mum1,mum12,mu2;
   XYZ p;

   mu2 = mu * mu;
   mum1 = 1 - mu;
   mum12 = mum1 * mum1;
   p.x = p1->x * mum12 + 2 * p2->x * mum1 * mu + p3->x * mu2;
   p.y = p1->y * mum12 + 2 * p2->y * mum1 * mu + p3->y * mu2;

   return(&p);
	}


XYZ *Bezier4 (XYZ *p0, XYZ *p1, XYZ *p2, XYZ *p3, double mu)
	{
	double ax,bx,cx, ay,by,cy;
	static XYZ p;

	cx = 3*((double)p1->x - (double)p0->x);
	bx = 3*((double)p2->x - (double)p1->x) - cx;
	ax = (double)p3->x - (double)p0->x - cx - bx;

	cy = 3*((double)p1->y - (double)p0->y);
	by = 3*((double)p2->y - (double)p1->y) - cy;
	ay = (double)p3->y - (double)p0->y - cy - by;

	p.x = ax*mu + bx*mu + cx*mu + p0->x;
	p.y = ay*mu + by*mu + cy*mu + p0->y;

	return (&p);
	}



int draw_path (short handle, short mode, struct graphical_state *path, struct path_objects *objects, unsigned long max_obj, short offset_x, short offset_y, short page_h, double scale)
{
	unsigned long done_objects=0, i=0, cur_x=-1, cur_y=-1;
	short *pxy = NULL, done = 0, max_objects = 0, pxy_bez[10]={0}, extent[6]={0}, totmoves, totsteps;
	char bez_art[24]={0};
	unsigned long px1=0, py1=0, px2=0, py2=0, px3=0, py3=0;
	double step=0;
	XYZ p1, p2, p3, p4, *out;
	double zoom_x=1, zoom_y=1;

	if(path->CTM.a!=0 && path->CTM.b==0 && path->CTM.c==0 && path->CTM.d!=0 && path->CTM.e==0 && path->CTM.f==0)
		{
		zoom_x = ((double)path->CTM.a)/(double)1000L;
		zoom_y = ((double)path->CTM.d)/(double)1000L;
		}

	max_obj = max_obj;

	while(objects[done_objects].type>0)
		{
		switch(objects[done_objects].type)
			{
			case 2:
				max_objects++;
				break;
			case 3:
				max_objects+=5;
				break;
			case 4:
			case 5:
			case 6:
				max_objects+=(10+(short)((double)1/(double)BEZIER_STEP));
				break;
			}
		done_objects++;
		}
	pxy = calloc(1, (max_objects*2+100)+16*10);
	done_objects=0;
	max_objects = 0;

	if(pxy==NULL)
		return(-1);


	while(objects[done_objects].type>0)
	{
		switch(objects[done_objects].type)
		{
			case 1:								/*	m		*/
				if(done==1)
					{
					vsl_type(handle, path->line_type);
					vsl_width(handle, (int)(path->line_width/1000));
					vsl_color(handle, path->line_color);
					vsf_color(handle, path->fill_color);
					vsf_interior(handle, FIS_SOLID);

					if(mode==(PATH_PAINTING_OPERATOR+7) || mode==(PATH_PAINTING_OPERATOR+8) || mode==(PATH_PAINTING_OPERATOR+9) || mode==(PATH_PAINTING_OPERATOR+1))
						{
						*(pxy + max_objects + 0) = *(pxy+0);
						*(pxy + max_objects + 1) = *(pxy+1);
						max_objects += 2;
						}

					if(mode==(PATH_PAINTING_OPERATOR+2) || mode==(PATH_PAINTING_OPERATOR+3))					/* f, F	-> 2, 3	*/
						v_fillarea (handle, max_objects / 2, pxy);
					else if(mode==(PATH_PAINTING_OPERATOR+4))					/* f*	-> 4	*/
						v_fillarea ( handle, max_objects/2, pxy);
					else if(mode==(PATH_PAINTING_OPERATOR+5))					/* B	-> 5	*/
						{
						v_fillarea ( handle, max_objects/2, pxy);				/*	f		*/
						v_pline(handle, max_objects/2, pxy);						/*	s		*/
						}
					else if(mode==(PATH_PAINTING_OPERATOR+6))					/* B*	-> 6	*/
						{
						v_fillarea ( handle, max_objects/2, pxy);				/*	f*	*/
						v_pline(handle, max_objects/2, pxy);						/*	s		*/
						}
					else if(mode==(PATH_PAINTING_OPERATOR+7))					/* b	-> 7	*/
						{
						v_fillarea ( handle, max_objects/2, pxy);				/*	f		*/
						v_pline(handle, max_objects/2, pxy);						/*	s		*/
							}
						else if(mode==(PATH_PAINTING_OPERATOR+8))					/* b*	-> 8	*/
							{
							v_fillarea ( handle, max_objects/2, pxy);				/*	f*		*/
							v_pline(handle, max_objects/2, pxy);						/*	s		*/
							}
						else if(mode==(PATH_PAINTING_OPERATOR+9))					/* n	-> 9	*/
							{
							;
							}
						else if(mode==(PATH_PAINTING_OPERATOR+0))					/* S	-> 0	*/
							v_pline(handle, max_objects/2, pxy);
						else																							/* Stroking	(s -> 1)	*/
							{
							v_pline(handle, max_objects/2, pxy);
							}
						max_objects = 0;
						}

					path->pos_x = (signed long)(scale*(double)objects[done_objects].x1);
					path->pos_y = (signed long)(scale*(double)objects[done_objects].y1);
						cur_x = offset_x + (int)((unsigned long)(scale*(double)objects[done_objects].x1)/1000L);
						cur_y = offset_y + page_h - (int)((unsigned long)(scale*(double)objects[done_objects].y1)/1000L);
					done = 1;
					break;

			case 2:								/*	l		*/
					if(pxy!=NULL)
					{
						pxy[max_objects + 0] = offset_x + path->pos_x / 1000UL;
						pxy[max_objects + 1] = offset_y + page_h - path->pos_y / 1000UL;
						i = 2;

						while(objects[done_objects].type==2)
							{
							pxy[max_objects + i + 0] = offset_x + (signed long)((scale*(double)objects[done_objects].x1)/1000L);							/*	End point		*/
							pxy[max_objects + i + 1] = offset_y + page_h - (signed long)((scale*(double)objects[done_objects].y1)/1000L);
							done_objects++;
							i+=2;
							}
						max_objects += i;
						done_objects--;

						path->pos_x = (signed long)objects[done_objects].x1/1L;											/* Set the new starting point	*/
						path->pos_y = (signed long)objects[done_objects].y1/1L;
						cur_x = offset_x + (int)((unsigned long)(scale*(double)objects[done_objects].x1)/1000L);
						cur_y = offset_y + page_h - (int)((unsigned long)(scale*(double)objects[done_objects].y1)/1000L);
						}
					break;

			case 3:								/*	re	*/
					pxy[max_objects + 0] = offset_x + (int)((unsigned long)(zoom_x*scale*(double)objects[done_objects].x1)/1000L);					/*		1,1	*/
					pxy[max_objects + 1] = offset_y + page_h - (int)((unsigned long)(zoom_y*scale*(double)objects[done_objects].y1)/1000L);
						
					pxy[max_objects + 4] = offset_x + (int)((unsigned long)(zoom_x*scale*(double)objects[done_objects].x2)/1000L);					/*		3,3	*/
					pxy[max_objects + 5] = offset_y + page_h - (int)((unsigned long)(zoom_y*scale*(double)objects[done_objects].y2)/1000L);

					pxy[max_objects + 2] = pxy[4];											/*		2,2	*/
					pxy[max_objects + 3] = pxy[1];

					pxy[max_objects + 6] = pxy[0];											/*		4,4	*/
					pxy[max_objects + 7] = pxy[5];

					pxy[max_objects + 8] = pxy[0];											/*		1,1	*/
					pxy[max_objects + 9] = pxy[1];
					
					max_objects += 10;

					break;
				
			case 4:																			/* c, v, y	*/
			case 5:
			case 6:
					px1 = objects[done_objects].x1;
					py1 = objects[done_objects].y1;
					px2 = objects[done_objects].x2;
					py2 = objects[done_objects].y2;
					px3 = objects[done_objects].x3;
					py3 = objects[done_objects].y3;

					if(cur_x==-1 && cur_y==-1)
						{
						cur_x = offset_x + (short)((scale * (double)px1) / 1000L);
						cur_y = offset_y + page_h - (short)((scale * (double)py1) / 1000L);
						}
					p1.x = cur_x;
					p1.y = cur_y;

					if(objects[done_objects].type==4)					/*	c	*/
						{
						p2.x = offset_x + (short)((scale * (double)px1) / 1000L);
						p2.y = offset_y + page_h - (short)((scale * (double)py1) / 1000L);

						p3.x = offset_x + (short)((scale * (double)px2) / 1000L);
						p3.y = offset_y + page_h - (short)((scale * (double)py2) / 1000L);

						p4.x = offset_x + (short)((scale * (double)px3) / 1000L);
						p4.y = offset_y + page_h - (short)((scale * (double)py3) / 1000L);
						}
					else if(objects[done_objects].type==5)		/*	v	*/
						{
						p2.x = p1.x;
						p2.y = p1.y;

						p3.x = offset_x + (short)((scale * (double)px2) / 1000L);
						p3.y = offset_y + page_h - (short)((scale * (double)py2) / 1000L);

						p4.x = offset_x + (short)((scale * (double)px3) / 1000L);
						p4.y = offset_y + page_h - (short)((scale * (double)py3) / 1000L);
						}
					else																			/*	y	*/
						{
						p2.x = offset_x + (short)((scale * (double)px1) / 1000L);
						p2.y = offset_y + page_h - (short)((scale * (double)py1) / 1000L);

						p3.x = p4.x = offset_x + (short)((scale * (double)px3) / 1000L);
						p3.y = p4.y = offset_y + page_h - (short)((scale * (double)py3) / 1000L);
						}

					cur_x = p4.x;	cur_y = p4.y;

					if(x_gem->speedo==TRUE)			/* NVDI or SpeedoGDOS				*/
						{
						vsl_type(handle, path->line_type);
						vsl_width(handle, (int)(path->line_width/1000));
						vsl_color(handle, path->line_color);

						memset(bez_art, BEZ_BEZIER, 24);
						v_set_app_buff( handle, &pxy, 10+(max_objects*2+100)/16);
						v_bez_qual(handle, 90, &extent[0]);
						pxy_bez[0] = p1.x;	pxy_bez[1] = p1.y;
						pxy_bez[2] = p2.x;	pxy_bez[3] = p2.y;
						pxy_bez[4] = p3.x;	pxy_bez[5] = p3.y;
						pxy_bez[6] = p4.x;	pxy_bez[7] = p4.y;
						extent[0] = v_bez_on(handle);
						v_bez(handle, 4, pxy_bez, bez_art, extent, &totsteps, &totmoves);
						v_bez_off(handle);
						v_set_app_buff( handle, NULL, 0);
						}
					else												/* No NVDI or SpeedoGDOS?		*/
						{
						for (step = 0; 1>step; step += BEZIER_STEP, max_objects += 2)
							{
							out = Bezier3 (&p1, &p3, &p4, step);
							pxy[max_objects + 0] = (short)out->x;
							pxy[max_objects + 1] = (short)out->y;
							}
						}

					path->pos_x = (signed long)((scale*(double)objects[done_objects].x3));						/* Set the new starting point */
					path->pos_y = (signed long)((scale*(double)objects[done_objects].y3));

			break;
		}
		done_objects ++;
	}

	vsl_type(handle, path->line_type);
	vsl_width(handle, (int)(path->line_width/1000));
	vsl_color(handle, path->line_color);
	vsf_color(handle, path->fill_color);
	vsf_interior(handle, FIS_SOLID);

	if(mode==(PATH_PAINTING_OPERATOR+7) || mode==(PATH_PAINTING_OPERATOR+8) || mode==(PATH_PAINTING_OPERATOR+9) || mode==(PATH_PAINTING_OPERATOR+1))
		{
		*(pxy + max_objects + 0) = *(pxy+0);
		*(pxy + max_objects + 1) = *(pxy+1);
		max_objects += 2;
		}

	if(mode==(PATH_PAINTING_OPERATOR+2) || mode==(PATH_PAINTING_OPERATOR+3))					/* f, F	-> 2, 3	*/
		v_fillarea ( handle, max_objects/2, pxy);
	else if(mode==(PATH_PAINTING_OPERATOR+4))					/* f*	-> 4	*/
		v_fillarea ( handle, max_objects/2, pxy);
	else if(mode==(PATH_PAINTING_OPERATOR+5))					/* B	-> 5	*/
		{
		v_fillarea ( handle, max_objects/2, pxy);				/*	f		*/
		v_pline(handle, max_objects/2, pxy);						/*	s		*/
		}
	else if(mode==(PATH_PAINTING_OPERATOR+6))					/* B*	-> 6	*/
		{
		v_fillarea ( handle, max_objects/2, pxy);				/*	f*	*/
		v_pline(handle, max_objects/2, pxy);						/*	s		*/
		}
	else if(mode==(PATH_PAINTING_OPERATOR+7))					/* b	-> 7	*/
		{
		/* Close the path first!!!	*/
		v_fillarea ( handle, max_objects/2, pxy);				/*	f		*/
		v_pline(handle, max_objects/2, pxy);						/*	s		*/
		}
	else if(mode==(PATH_PAINTING_OPERATOR+8))					/* b*	-> 8	*/
		{
		/* Close the path first!!!	*/
		v_fillarea ( handle, max_objects/2, pxy);				/*	f*		*/
		v_pline(handle, max_objects/2, pxy);						/*	s		*/
		}
	else if(mode==(PATH_PAINTING_OPERATOR+9))					/* n	-> 9	*/
		{
		/* Just close the path first!!!	*/
		}
	else if(mode==(PATH_PAINTING_OPERATOR+0))					/* S	-> 0	*/
		v_pline(handle, max_objects/2, pxy);
	else																							/* Stroking	(s -> 1)	*/
		{
		/* Just close the path first!!!	*/
		v_pline(handle, max_objects/2, pxy);
		}

	done_objects = 0;
	free(pxy);
	return(1);
}
