#include "rc4.h"
#include <stdio.h>
#include <stdlib.h>
/*#include <unistd.h>*/
#include <string.h>
/*#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <pwd.h>*/




/*rc4.c */
static void swap_byte(unsigned char *a, unsigned char *b);
void prepare_key(unsigned char *key_data_ptr, int key_data_len,
		 rc4_key *key)
{
   unsigned char index1;
   unsigned char index2;
   unsigned char* state;
   short counter;     

   state = &key->state[0];         
   for(counter = 0; counter < 256; counter++)              
   state[counter] = counter;               
   key->x = 0;     
   key->y = 0;     
   index1 = 0;     
   index2 = 0;             
   for(counter = 0; counter < 256; counter++)      
   {               
      index2 = (key_data_ptr[index1] + state[counter] +
                index2) % 256;                
      swap_byte(&state[counter], &state[index2]);            
      
      index1 = (index1 + 1) % key_data_len;  
   }       
}

void rc4(unsigned char *buffer_ptr, int buffer_len, rc4_key *key)
{ 
   unsigned char x;
   unsigned char y;
   unsigned char* state;
   unsigned char xorIndex;
   short counter;              
   
   x = key->x;     
   y = key->y;     
   
   state = &key->state[0];         
   for(counter = 0; counter < buffer_len; counter ++)      
   {               
      x = (x + 1) % 256;                      
      y = (state[x] + y) % 256;               
      swap_byte(&state[x], &state[y]);                        
      
      xorIndex = (state[x] + state[y]) % 256;                 
      
      buffer_ptr[counter] ^= state[xorIndex];         
   }               
   key->x = x;     
   key->y = y;
}

static void swap_byte(unsigned char *a, unsigned char *b)
{
   unsigned char swapByte; 
   
   swapByte = *a; 
   *a = *b;      
   *b = swapByte;
}







int main(int argc,char **argv) {
		char buf[256];
		char key[128];
		char *keyptr=NULL;
		char *generation="65536";
		rc4_key rc4k;
		int fd;
		long unsigned int offset;
		int done,len;
		
		argv[0]="proba2.pdf";
		argc=2;

		if (argc !=2) {
					fprintf(stderr,"usage: %s filename\n",argv[0]);
					exit(1);
		}
		
		if((fd=open(argv[1],O_RDWR|O_EXCL))==-1) {
				fprintf(stderr,"error opening file %s! Exiting.. \n",
									argv[1]);
		}
		
		done=0;
		while(!done) {
				keyptr = "MyPDF";
				strcpy(&key[0], "MyPDF");
				done=1;
		}
		fprintf(stderr,"\nKey accepted\nCiphering .. ");
		
		offset=0;
		prepare_key(key,strlen(key),&rc4k);
		while((len=read(fd,buf,256))!=0) {
				rc4(buf,len,&rc4k);
				lseek(fd,offset,SEEK_SET);
				write(fd,buf,len);
				offset+=len;
		}
				
		fprintf(stderr,"done\n");
		close(fd);
return 0;
}
