#include	<mgem.h>
#include	<portab.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<tos.h>
#include	<ctype.h>
#include	<x_gem.h>
#include	"memdebug.h"
#include	"mp_const.h"
#include	"typespdf.h"
#include	"info_pdf.h"
#include	"files.h"
#include	"status.h"
#include	"options.h"
#include	"cont_pat.h"
#include	"windinfo.h"


extern X_GEM_INFO *x_gem;

int Command2ID(struct files_pdf *, char **);
unsigned long Read_object_no(struct files_pdf *);
int read_object_no(int );
char *Read_last_line(struct files_pdf *);
char *Read_line(struct files_pdf *);
char *Read_prev_line(struct files_pdf *);
char *read_prev_line(int );
char *Read_text(struct files_pdf *);
char *Read_type(struct files_pdf *);


struct Rectangle *Read_rectangle(struct files_pdf *);
struct Page_tree *read_Page_tree(struct files_pdf *file, long *obj);

double Get_Scale(int page_w, int page_h, int win_w, int win_h, int mode);

void Change_progress_bar (int status, int window, unsigned long value, unsigned long max_value);

struct PDF_PageTree *find_page_tree(struct PDF_Info *info, struct PDF_PageTree *page, int page_no, int max);

long find_object_number (struct file_position *, int , unsigned int );
BOOLEAN load_objects(struct files_pdf);
BOOLEAN Load_objects(struct PDF_Info *,int);

void Depack_date(char *);

BOOLEAN GoToObject(struct PDF_Info *, unsigned int );
BOOLEAN GoBack(struct PDF_Info *);

extern char *types_command[];

#define ANNOTS_TYPE			1
#define ANNOTS_SUBTYPE	2
#define ANNOTS_P				3
#define ANNOTS_RECT			4
#define ANNOTS_M				5
#define ANNOTS_F				6
#define ANNOTS_BORDER		7
#define LINK_ANNOTS_DEST				(ANNOTS_BORDER+1)
#define LINK_ANNOTS_A						(ANNOTS_BORDER+2)
#define LINK_ANNOTS_H						(ANNOTS_BORDER+3)
#define LINK_ANNOTS_N						(ANNOTS_BORDER+4)
#define LINK_ANNOTS_I						(ANNOTS_BORDER+5)
#define LINK_ANNOTS_O						(ANNOTS_BORDER+6)
#define LINK_ANNOTS_P						(ANNOTS_BORDER+7)
#define LINK_ANNOTS_PA					(ANNOTS_BORDER+8)


char *annotations_command[]={
		"/Type",
		"/Subtype",
		"/P",
		"/Rect",
		"/M",
		"/F",
		"/Border",

/* FOR LINK ANNOTATIONS	*/
		"/Dest",
		"/A",
		"/H",
		"/N",
		"/I",
		"/O",
		"/P",
		"/PA",

		NULL};

#define ANNOTS_SUB_LINK	1

char *annots_subtype[]={
		"/Link",
		NULL};

char *boolean_commands[]={
		"TRUE",
		"FALSE",
		NULL};




void Load_annotations(struct PDF_Info *info, struct PDF_PageTree *page_tree)
	{
	struct files_pdf *file = info->file_info;
	struct Rectangle *rect=NULL;
	struct annotations *tmp_annot=NULL;
	struct Page_tree *pages=NULL;
	int keep_going=1, i=0;
	long obj=0;

	file->actual_pos = page_tree->Annots;
	pages = read_Page_tree(file, &obj);

	tmp_annot = calloc (obj+1, sizeof (struct annotations));
	page_tree->how_many_annotations = 0;

	while(pages[i].page_no>-1)
		{
		Change_progress_bar (STATUS_BAR1_UPDATE, x_gem->top_wind, (unsigned long)i, (unsigned long)obj);
		GoToObject(info, pages[i].page_no);

		keep_going=1;

		if(tmp_annot)
			{
			page_tree->how_many_annotations++;
			while(keep_going!=0)
				{
				switch((keep_going=Command2ID(file, annotations_command)))
					{
					case ANNOTS_TYPE:
							if((tmp_annot[i].type = Command2ID(file, types_command))!=8)
								{
								x_gem_alert("[1][Wrong annotations...][Again?]", 0L);
								return;
								}
							break;

					case ANNOTS_SUBTYPE:
							tmp_annot[i].subtype = Command2ID(file, annots_subtype);
							break;

					case ANNOTS_P:
							tmp_annot[i].p = file->actual_pos;
							break;

					case ANNOTS_RECT:
							if((rect=Read_rectangle(file))!=NULL)
								{
								memcpy(&tmp_annot[i].rect, rect, sizeof(struct Rectangle));
								free(rect);
								}
							break;

					case ANNOTS_M:
							tmp_annot[i].M = file->actual_pos;
							break;

					case ANNOTS_F:
							tmp_annot[i].F = (int)Read_object_no(file);
							break;

					case ANNOTS_BORDER:
							break;

					case LINK_ANNOTS_DEST:
							tmp_annot[i].Dest = file->actual_pos;
							break;

					case LINK_ANNOTS_A:
							tmp_annot[i].A = file->actual_pos;
							break;

					case LINK_ANNOTS_H:
							tmp_annot[i].H = file->actual_pos;
							break;

					case LINK_ANNOTS_N:
/*							tmp_annot[i].N = Command2ID(file, annots_subtype);
*/							break;

					case LINK_ANNOTS_I:
/*							tmp_annot[i].I = Command2ID(file, annots_subtype);
*/							break;

					case LINK_ANNOTS_O:
/*							tmp_annot[i].O = Command2ID(file, annots_subtype);
*/							break;

					case LINK_ANNOTS_P:
/*							tmp_annot[i].F = Command2ID(file, annots_subtype);
*/							break;

					case LINK_ANNOTS_PA:
							tmp_annot[i].PA = file->actual_pos;
							break;

					default:
							break;
					}
				}
			}
		i++;
		GoBack(info);
		}

	page_tree->annots = tmp_annot;
	free(pages);
	}


void Check_annotations(int event)
	{
	short window, x, y, rect_x1, rect_y1, rect_x2, rect_y2, page_w, page_h, win_w, win_h,i;
	WIND_LIST *wind;
	WIND_INFO *wind_info;
	struct PDF_Info *pdf_info;
	struct PDF_PageTree *page_tree;
	struct annotations *annots;
	double scale=1;
	static BOOLEAN prev_state;
	

	if((window = x_gem->event_wind)==-1)
		return;
	wind = &x_gem->wind[window];
	wind_info = (WIND_INFO *)wind->w_user1;

	if(wind_info==NULL)
		return;
	pdf_info = wind_info->pdf_info;
	if(pdf_info==NULL)
		return;
	page_tree = find_page_tree(pdf_info, NULL, (int)pdf_info->page_no, 1);		/* The actual page */
	annots = page_tree->annots;

	if(annots==NULL)
		return;

	x = wind->w_work_wind.g_x - (short)wind->w_pos_x;
	y = wind->w_work_wind.g_y - (short)wind->w_pos_y;
	win_w = wind->w_work_wind.g_w;
	win_h = wind->w_work_wind.g_h;

	page_w = page_tree->MediaBox.x2;			/* PDF page format - width	*/
	page_h = page_tree->MediaBox.y2;			/* PDF page format - height	*/

	scale = Get_Scale(page_w, page_h, win_w, win_h, pdf_info->zoom);
	page_w = (unsigned long)(scale * (double)page_w);			/* PDF page format - width	(scaled)	*/
	page_h = (unsigned long)(scale * (double)page_h);			/* PDF page format - height	(scaled)	*/

	i=0;
	while(annots[i].type==8)								/* Are this still link annotations?	*/
		{
		if(event!=MU_BUTTON)
			{
			switch(annots[i].subtype)
				{
				case ANNOTS_SUB_LINK:
					rect_x1 = x + (int)(scale*(double)(annots[i].rect.x1));
					rect_y1 = y + page_h - (int)(scale*(double)(annots[i].rect.y1));
					rect_x2 = x + (int)(scale*(double)(annots[i].rect.x2));
					rect_y2 = y + page_h - (int)(scale*(double)(annots[i].rect.y2));

					if(	x_gem->mx>rect_x1 && x_gem->mx<rect_x2 && x_gem->my<rect_y1 && x_gem->my>rect_y2)
						{
						if(prev_state!=TRUE)
							graf_mouse(POINT_HAND,NULL);
						prev_state=TRUE;
						return;
						}
					break;
				}
			}
		else
			{
			switch(annots[i].subtype)
				{
				case ANNOTS_SUB_LINK:
					rect_x1 = x + (int)(scale*(double)(annots[i].rect.x1));
					rect_y1 = y + page_h - (int)(scale*(double)(annots[i].rect.y1));
					rect_x2 = x + (int)(scale*(double)(annots[i].rect.x2));
					rect_y2 = y + page_h - (int)(scale*(double)(annots[i].rect.y2));

					if(	x_gem->mx>rect_x1 && x_gem->mx<rect_x2 && x_gem->my<rect_y1 && x_gem->my>rect_y2)
						{
						if(prev_state!=TRUE)
							{
							graf_mouse(POINT_HAND,NULL);
							printf("*");
							}
						prev_state=TRUE;
						return;
						}
					break;
				}
			}
		i++;
		}

	if(prev_state==TRUE)
		graf_mouse(ARROW ,NULL);
	prev_state=FALSE;
	}