#include	<ext.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>
#include	<x_gem.h>
#include	"mypdf.h"
#include	"mypdf.rh"
#include	"files.h"
#include	"typespdf.h"
#include	"info_pdf.h"
#include	"status.h"
#include	"trailer.h"
#include	"options.h"
#include	"mp_const.h"
#include	"memdebug.h"
#include	"page_con.h"


BOOLEAN Free_Outline(struct PDF_Outline *);
BOOLEAN FreeThreads(struct PDF_Threads *);
BOOLEAN Free_Page_Tree(struct PDF_Info *);
BOOLEAN Free_Page_labeling(struct PDF_Info *);
BOOLEAN Free_NameTree(struct PDF_Info *);

void Free_Page_Contents(struct page_contents *);
void Free_font(struct page_resource *);
void FreePicture(struct picture *pic);

unsigned long Read_object_no(struct files_pdf *);
char *Read_text(struct files_pdf *);
char *Read_type(struct files_pdf *);
char *Read_line (struct files_pdf *);
struct Rectangle *Read_rectangle(struct files_pdf *);

char *PageNumber(struct PDF_Info *info, int page_no, char *string);


extern struct file_position *root_position;
extern struct PDF_Info *root_pdf_info_find;
extern struct file_position *root_position;
extern struct PDF_Info *root_pdf_info;

void FreePDF (struct PDF_Info *pdf_info)
{
	if (pdf_info->next_pdf_info)
	{
		if(pdf_info->prev_pdf_info)
		{
			pdf_info->prev_pdf_info->next_pdf_info = pdf_info->next_pdf_info;
			pdf_info->next_pdf_info->prev_pdf_info = pdf_info->prev_pdf_info;
		}
		else
		{
			root_pdf_info = pdf_info->next_pdf_info;
		}
	}

	if (pdf_info->Title)
		free (pdf_info->Title);
	if (pdf_info->Author)
		free (pdf_info->Author);
	if (pdf_info->Subject)
		free (pdf_info->Subject);
	if (pdf_info->Keywords)
		free (pdf_info->Keywords);
	if (pdf_info->Creator)
		free (pdf_info->Creator);
	if (pdf_info->Producer)
		free (pdf_info->Producer);
	if (pdf_info->CreationDate)
		free (pdf_info->CreationDate);
	if (pdf_info->ModDate)
		free (pdf_info->ModDate);
	if (pdf_info->Trapped)
		free (pdf_info->Trapped);
	pdf_info->Version = 0;

	if (pdf_info->file_info)
	{
		if (pdf_info->file_info->name)
			free (pdf_info->file_info->name);
		if (pdf_info->file_info->buffer)
			free (pdf_info->file_info->buffer);
		if (pdf_info->file_info->next)
			free (pdf_info->file_info->next);
		if (pdf_info->file_info->prev)
			free (pdf_info->file_info->prev);
		free (pdf_info->file_info);
	}
	
	if (pdf_info->trailer)
		free (pdf_info->trailer);

	if (pdf_info->encryption)
	{
		free (pdf_info->encryption);
	}

/* Root information	*/
	if(pdf_info->Root_obj)
	{
/*		if(pdf_info->Root_obj->Names)
			free(pdf_info->Root_obj->Names);	*/
		if(pdf_info->Root_obj->Dests)
			free(pdf_info->Root_obj->Dests);
		if(pdf_info->Root_obj->ViewerPreferences)
			free(pdf_info->Root_obj->ViewerPreferences);
		if(pdf_info->Root_obj->OpenAction)
			free(pdf_info->Root_obj->OpenAction);
		if(pdf_info->Root_obj->URI)
			free(pdf_info->Root_obj->URI);
		if(pdf_info->Root_obj->AcroForm)
			free(pdf_info->Root_obj->AcroForm);
		if(pdf_info->Root_obj->StructTreeRoot)
			free(pdf_info->Root_obj->StructTreeRoot);
		if(pdf_info->Root_obj->SpiderInfo)
			free(pdf_info->Root_obj->SpiderInfo);
		free(pdf_info->Root_obj);
	}

	Free_Page_Tree(pdf_info);						/* Frees the page tree - required	*/
	Free_Page_labeling(pdf_info);
	Free_NameTree(pdf_info);							/* Name tree	*/

/* Outline information	*/
	if(pdf_info->Outline)
	{
		Free_Outline(pdf_info->Outline);
	}

/* Article threads			*/
	if(pdf_info->Threads)
	{
		FreeThreads(pdf_info->Threads);
	}

	if(pdf_info->pages_contents[2].adress)
		Free_Page_Contents((struct page_contents *)pdf_info->pages_contents[2].adress);
	if(pdf_info->pages_contents[1].adress)
		Free_Page_Contents((struct page_contents *)pdf_info->pages_contents[1].adress);
	if(pdf_info->pages_contents[0].adress)
		Free_Page_Contents((struct page_contents *)pdf_info->pages_contents[0].adress);

	if (pdf_info == root_pdf_info)
	{
		free (root_pdf_info);
		root_pdf_info = NULL;
	}
	else
		free (pdf_info);

	Read_object_no(NULL);
	Read_rectangle(NULL);
	Read_text(NULL);
	Read_type(NULL);
	Read_line(NULL);
	PageNumber(NULL, 0, NULL);
}



void Free_Page_Contents(struct page_contents *page)
	{
	if(page)
		{
		if(page->resource)
			{
			if(page->resource->fonts)
				Free_font(page->resource);
			if(page->resource->pictures)
				FreePicture(page->resource->pictures);
			free(page->resource);
			}
		free(page->content);
		free(page);
		}
	}