#include	<mgem.h>
#include	<portab.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<tos.h>
#include	<ctype.h>
#include	<math.h>
#include	"memdebug.h"
#include	"mp_const.h"
#include	"typespdf.h"
#include	"info_pdf.h"
#include	"files.h"
#include	"status.h"
#include	"options.h"


int Command2ID(struct files_pdf *, char **);
unsigned long Read_object_no(struct files_pdf *);
int read_object_no(int );
char *Read_line (struct files_pdf *);
char *Read_command(struct files_pdf *);
char *Read_text(struct files_pdf *);
BOOLEAN GoToObject(struct PDF_Info *, unsigned int );
BOOLEAN GoBack(struct PDF_Info *);
struct page_label_dict *read_page_labels_dict(struct PDF_Info *, int, struct Page_nums *);

extern struct opt options;


extern char *types_command[];

char *page_label_commands[]={
		"/Kids",
		"/Nums",
		"/Limits",
		NULL};

char *page_label_dict_command[]={
		"/Type",
		"/S",
		"/P",
		"/St",
		NULL};

char *numbering_style[]={
		"/D",
		"/R",
		"/r",
		"/A",
		"/a",
		NULL};



BOOLEAN Free_Page_labeling(struct PDF_Info *info)
	{
	if(info->pagelabels)
		{
		if(info->pagelabels->nums)
			free(info->pagelabels->nums);

		if(info->pagelabels->Nums)
			free(info->pagelabels->Nums);

		free(info->pagelabels);
		}

	return(TRUE);			/* Page tree is required	*/
	}




struct Page_nums *read_Page_nums(struct files_pdf *file, int *obj)
	{
	struct Page_nums *output=NULL, *temp=NULL;
	unsigned long pos=file->actual_pos;
	int nr=0;
	BOOLEAN keep_going=TRUE;
	unsigned long adress;

	temp = calloc(100, sizeof (struct Page_nums));
	adress = (unsigned long)temp;
	if(obj!=NULL)
		(*obj) = 1;

	if(temp!=NULL)
		{
		if(file->handle<=0)
			{
			while(file->buffer[pos++]!='[')	;											/* Let's find the beginning	*/

			while(keep_going!=FALSE)															/* Is there still something to read?	*/
				{
				while(isdigit(file->buffer[pos])==0)
					{
					if(file->buffer[pos]==']')
						{
						keep_going=FALSE;
						break;
						}
					pos++;
					}

				if(keep_going!=FALSE)
					{
					temp->start_page = atoi(&(file->buffer[pos-1]));		/* Number of the start page	*/
					while(file->buffer[pos++]!=' ')	;

					temp->obj_num = atol(&(file->buffer[pos-1]));				/* Number of the page	*/
					while(file->buffer[pos++]!=' ')	;

					while(isdigit(file->buffer[pos++])==0)	;
					temp->eval = atoi(&(file->buffer[pos-1]));					/* Evaluation number	*/
					while(file->buffer[pos++]!=' ')	;

					temp->Type = file->buffer[pos];

					while(isspace(file->buffer[pos])==0)								/* Go to the next kid	*/
						{
						if(file->buffer[pos]==']' || file->buffer[pos+1]==']')												/* or is it the end of the kids?	*/
							{
							keep_going=FALSE;																/*	yes	*/
							break;
							}
						pos++;																						/* no		*/
						}
					nr++;																								/* How many kids are there?				*/
					((unsigned long)temp) += sizeof (struct Page_nums);	/*		*/

					if(file->buffer[pos]==']' || file->buffer[pos+1]==']')												/* or is it the end of the kids?	*/
						{
						keep_going=FALSE;																/*	yes	*/
						break;
						}

					if(obj!=NULL)
						(*obj)++;
					}
				}
			}
		else
			{
					/* Read Page_nums from a file	*/
			}

		output = calloc(nr+1, sizeof (struct Page_nums));
		memset((void*)output, -1, nr+1*sizeof (struct Page_nums));
		memcpy(output, (void*)adress, nr*sizeof (struct Page_nums));		/* Copy the contents	*/
		free((void*)adress);
		}
	return(output);
	}


struct page_labels *read_page_labels(struct PDF_Info *info)
	{
	struct files_pdf *file = info->file_info;
	struct page_labels *page_label=NULL;
	int keep_going=1;

	page_label = calloc (1, sizeof (struct page_labels));
	memset(page_label, 0, sizeof (struct page_labels));

	if(page_label)
		{
		GoToObject(info, (unsigned int)info->Root_obj->PageLabels);

		Read_line(file);

		while(keep_going!=0)
			{
			switch((keep_going=Command2ID(file, page_label_commands)))
				{
				case PAGE_LABEL_KIDS:
							page_label->Kids = Read_object_no(file);
							break;
				case PAGE_LABEL_NUMS:
							page_label->Nums = read_Page_nums(file, &(page_label->nums_acc));
							break;
				case PAGE_LABEL_LIMITS:
							page_label->Limits = Read_object_no(file);
							break;
				default:
							break;
				}
			}

		if(page_label->Nums)
			{
			page_label->nums = read_page_labels_dict(info, page_label->nums_acc, page_label->Nums);
			}
		info->pagelabels = page_label;
		}

	GoBack(info);
	return(page_label);
	}


struct page_label_dict *read_page_labels_dict(struct PDF_Info *info, int how_many, struct Page_nums *objs)
	{
	struct files_pdf *file = info->file_info;
	char *line;
	struct page_label_dict *output=NULL, *temp=NULL;
	int i=0, keep_going=1;

	output = calloc(how_many, sizeof(struct page_label_dict));
	memset(output, 0, how_many*sizeof (struct page_label_dict));


	while(how_many>0)
		{
		temp = &output[i];
		i++;
		how_many--;
		keep_going = 1;

		if(temp)
		{
/*			Change_status(STATUS_PDF_PAGE_LABELING, 0, 0);
			Change_status(STATUS_BAR1_UPDATE, 0, 0);*/

			GoToObject(info, (unsigned int)(objs[i].obj_num));

			line = Read_line(file);

			while(keep_going!=0)
				{
				switch((keep_going=Command2ID(file, page_label_dict_command)))
					{
					case PAGE_LABEL_DICT_TYPE:
								temp->Type = Command2ID(file, types_command);
								break;

					case PAGE_LABEL_DICT_S:
								temp->S = Command2ID(file, numbering_style);
								break;

					case PAGE_LABEL_DICT_P:
								line = Read_text(file);
								if(line!=NULL)
									{
									strcpy(temp->P, line);
									free(line);
									}
								break;

					case PAGE_LABEL_DICT_St:
								temp->St = (int)Read_object_no(file);
								break;

					default:
								break;
					}
				}
			}
		}

	GoBack(info);
	return(output);
	}


char *PageNumber(struct PDF_Info *info, int page_no, char *string)
	{
	static char *output;
	char buf[10], *_output=NULL;
	struct Page_nums *temp2=NULL;
	struct page_label_dict *temp3=NULL;
	int i=0, nr=0, diff=0;
	char *Roman10[]={		"I",	"II",	"III",	"IV",	"V",	"VI",	"VII",	"VIII",	"IX"};
	char *Roman100[]={	"X",	"XX",	"XXX",	"XL",	"L",	"LX",	"LXX",	"LXXX",	"XC"};
	char *Roman1000[]={	"C",	"CC",	"CCC",	"CD",	"D",	"DC",	"DCC",	"DCCC",	"CM"};
	char *Roman10000[]={"M",	"MM",	"MMM",	"MMMM",	"MMMMM",	"MMMMMM",	"MMMMMMM",	"MMMMMMMM",	"MMMMMMMMM",	"MMMMMMMMMM"};

	if(info==NULL)
		return(NULL);
/*		if(output!=NULL)
			{
			free(output);
			return(NULL);
			}
*/
	if(info->pagelabels!=NULL && info->pagelabels->nums!=NULL)
		{
		if(string==NULL)
			{
			output = calloc(1, 256);
			string = output;
			}
		else
			{
			(*string)=0;
			output=string;
			}

		temp2 = &(info->pagelabels->Nums[0]);
		temp3 = &(info->pagelabels->nums[0]);
		while(i<info->pagelabels->nums_acc)
			{
			i++;
			if((page_no>=temp2->start_page && page_no<=(info->pagelabels->Nums[i]).start_page) || i==info->pagelabels->nums_acc)
				break;
			temp2 = &(info->pagelabels->Nums[i]);
			temp3 = &(info->pagelabels->nums[i]);
			}

		if(strlen(temp3->P)>0)
			strcpy(output, &temp3->P[0]);

/*		if(temp2->start_page==0)	*/
			nr = page_no - temp2->start_page;
	/*	else
			nr = page_no - temp2->start_page + 1;	*/

		switch((temp3->S+1))
			{
			case NUMBERING_STYLE_D:					/* Decimal arabic numerals	*/
					strcat(output, itoa(nr+temp3->St, &buf[0], 10));
					break;

			case NUMBERING_STYLE_R:					/* Roman uppercase	*/
					nr = nr+temp3->St;
					if(nr>=1000)
						strcat(output, Roman10000[(nr/1000)-1]);		nr = nr - (nr/1000)*1000;
					if(nr>=100)
						strcat(output, Roman1000[(nr/100)-1]);			nr = nr - (nr/100)*100;
					if(nr>=10)
						strcat(output, Roman100[(nr/10)-1]);				nr = nr - (nr/10)*10;
					if(nr>0)
						strcat(output, Roman10[nr-1]);
					break;

			case NUMBERING_STYLE_r:					/* Roman lowercase	*/
					nr = nr+temp3->St;
					if(nr>=1000)
						strcat(output, strlwr(Roman10000[(nr/1000)-1]));		nr = nr - (nr/1000)*1000;
					if(nr>=100)
						strcat(output, strlwr(Roman1000[(nr/100)-1]));			nr = nr - (nr/100)*100;
					if(nr>=10)
						strcat(output, strlwr(Roman100[(nr/10)-1]));				nr = nr - (nr/10)*10;
					if(nr>0)
						strcat(output, strlwr(Roman10[nr-1]));
					break;

			case NUMBERING_STYLE_A:					/* Uppercase lettter A...Z, AA..ZZ, AAA...ZZZ etc.	*/
					nr += temp3->St;
					if(nr>26)
						{
						diff = (int)((nr-1)/26);
						nr = nr-diff*26;
						}
					nr--;
					memset(output, nr+'A', diff+1);
					break;
			case NUMBERING_STYLE_a:					/* Lowercase lettter a...z, aa..zz, aaa...zz etc.		*/
					nr += temp3->St;
					if(nr>26)
						{
						diff = (int)((nr-1)/26);
						nr = nr-diff*26;
						}
					nr--;
					memset(output, nr+'a', diff+1);
					break;
			}
		}
	else
		{
		if(string==NULL)
			{
			output = calloc(1, 256);
			string = output;
			}
		else
			output=string;

		itoa(page_no, output, 10);
		}

	_output = output;
	return(_output);
	}