#include	<mgem.h>
#include	<portab.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<tos.h>
#include	<ctype.h>
#include	<x_gem.h>
#include	"memdebug.h"
#include	"mp_const.h"
#include	"typespdf.h"
#include	"info_pdf.h"
#include	"files.h"
#include	"status.h"
#include	"options.h"
#include	"mypdf.h"

int Command2ID(struct files_pdf *, char **);
unsigned long Read_object_no(struct files_pdf *);
int read_object_no(int );
char *Read_last_line(struct files_pdf *);
char *Read_line(struct files_pdf *);
char *Read_prev_line(struct files_pdf *);
char *read_prev_line(int );
char *Read_text(struct files_pdf *);
char *Read_type(struct files_pdf *);

struct ThumbNail *read_thumbnails(struct PDF_Info *, int , struct ThumbNail *);
void Load_annotations(struct PDF_Info *info, struct PDF_PageTree *page_tree);

struct Rectangle *Read_rectangle(struct files_pdf *);
char *PageNumber(struct PDF_Info *, int , char *);

void Add_entry2steps(int value);

long find_object_number (struct file_position *, int , unsigned int );
BOOLEAN load_objects(struct files_pdf);
BOOLEAN Load_objects(struct PDF_Info *,int);

void Depack_date(char *);

BOOLEAN GoToObject(struct PDF_Info *, unsigned int );
BOOLEAN GoBack(struct PDF_Info *);

extern struct opt options;
extern struct Root_obj *read_root_obj(struct PDF_Trailer *trailer, struct PDF_Info *info);

extern short wh_status;
extern X_GEM_INFO *x_gem;
extern WIND_LIST windows[];

char *types_command[]={
		"/Page",
		"/Pages",
		"/XObject",
		"/Catalog",
		"/Outlines",
		"/Font",
		"/FontDescriptor",
		"/Annot",
		NULL};

char *pagetree_commands[]={
		"/Type",
		"/Parent",
		"/Kids",
		"/Count",
		"/ID",
		"/Resources",
		"/MediaBox",
		"/CropBox",
		"/BleedBox",
		"/TrimBox",
		"/ArtBox",
		"/Contents",
		"/Rotate",
		"/Thumb",
		"/B",
		"/Dur",
		"/Trans",
		"/Annots",
		"/AA",
		"/PieceInfo",
		"/LastModified",
		"/StructParents",
		"/PZ",
		"/SeparationInfo",
		NULL};



BOOLEAN Free_Page_Tree(struct PDF_Info *info)
	{
	unsigned long i=0;
	struct PDF_PageTree *page_tree=NULL;

	if(info->pages)
		{
		if(info->pages->first_kid)
			{
			for(i=0; i<info->pages->already_loaded; i++)
				{
				page_tree = (struct PDF_PageTree *)(&(info->pages->first_kid[i]));

				if(page_tree->B)
					free(page_tree->B);

				if(page_tree->annots!=NULL)
					free(page_tree->annots);

				if(page_tree->Page_no!=NULL)
					free(page_tree->Page_no);

				if(page_tree->LastModified)
					free(page_tree->LastModified);

				if(page_tree->kids)
					free(page_tree->kids);

				if(page_tree->B)
					free(page_tree->B);
				}
			}
		if(info->pages->first_kid)
			free(info->pages->first_kid);
		free(info->pages);
		return(TRUE);
		}
	else
		{
		return(FALSE);							/* Page tree is required	*/
		}
	}




void GoToPage(struct PDF_Info *pdf_info, int page_no)
	{
	int k=0;
	struct PDF_PageTree *page_tree=pdf_info->pages;

	if(page_tree)
		{
		while(page_tree[k].real_number!=page_no && k<pdf_info->pages->max_to_load)
			k++;

		pdf_info->file_info->actual_pos = page_tree->Contents;			/*	GoToObject(pdf_info, page_tree->Contents);	*/
		}
	}


struct Page_tree *read_Page_tree(struct files_pdf *file, long *obj)
	{
	struct Page_tree *output=NULL, *temp=NULL;
	unsigned long pos=file->actual_pos;
	int nr=0;
	BOOLEAN keep_going=TRUE;
	unsigned long adress;

	temp = calloc(500, sizeof (struct Page_tree));
	adress = (unsigned long)temp;
	if(obj!=NULL)
		*obj = 1;

	if(temp!=NULL)
		{
		while(file->buffer[pos++]!='[')	;											/* Let's find the beginning	*/

		while(keep_going!=FALSE)															/* Is there still something to read?	*/
			{
			while(isdigit(file->buffer[pos])==0)
				{
				if(file->buffer[pos]==']')
					{
					keep_going=FALSE;
					break;
					}
				pos++;
				}

			if(keep_going!=FALSE)
				{
				if(isdigit(file->buffer[pos-1])!=0)
					temp->page_no = atoi(&(file->buffer[pos-1]));				/* Number of the page	*/
				else
					temp->page_no = atoi(&(file->buffer[pos]));				/* Number of the page	*/
					
				pos += strcspn(&(file->buffer[pos]), " ");
				pos--;

				while(isdigit(file->buffer[++pos])==0)	;
				temp->eval = atoi(&(file->buffer[pos-1]));					/* Evaluation number	*/
				pos += strcspn(&(file->buffer[pos]), " ");


				if(file->buffer[pos]==' ')
					pos++;

				temp->Type = file->buffer[pos];

				while(isspace(file->buffer[pos])==0)								/* Go to the next kid	*/
					{
					if(file->buffer[pos]==']' || file->buffer[pos+1]==']')												/* or is it the end of the kids?	*/
						{
						keep_going=FALSE;																/*	yes	*/
						break;
						}
					pos++;																						/* no		*/
					}
				nr++;																								/* How many kids are there?				*/
				((unsigned long)temp) += sizeof (struct Page_tree);	/*		*/

				if(file->buffer[pos]==']' || file->buffer[pos+1]==']')												/* or is it the end of the kids?	*/
					{
					keep_going=FALSE;																/*	yes	*/
					break;
					}

				if(obj!=NULL)
					(*obj)++;
				}
			}

		output = calloc(nr+1, sizeof (struct Page_tree));
		memset((void*)output, -1, (nr+1)*sizeof (struct Page_tree));
		memcpy(output, (void*)adress, nr*sizeof (struct Page_tree));		/* Copy the contents	*/
		free((void*)adress);

		}
	return(output);
	}





struct PDF_PageTree *read_page_tree_node(struct PDF_Info *info, unsigned int obj, int how_many, struct Page_tree *table)
	{
	struct files_pdf *file = info->file_info;
	char *line, buf[256]={0};
	struct PDF_PageTree *page_tree=NULL;
	struct Rectangle *rect=NULL;
	unsigned long already_loaded=0, pagetree_kids_pos=0;
	int keep_going=1, i=0;

	table=table;

	page_tree = calloc (1, sizeof (struct PDF_PageTree));

		{
		if(info->pages)
			already_loaded = info->pages->already_loaded;

		GoToObject(info, obj);

		page_tree->page_in_pdf = obj;

		keep_going=1;

		if(page_tree && obj>0)
			{
			line = Read_line(file);

			while(keep_going!=0)
				{
				switch((keep_going=Command2ID(file, pagetree_commands)))
					{
					case PAGETREE_TYPE:
							page_tree->Type = Command2ID(file, types_command);
							break;

					case PAGETREE_PARENT:
							page_tree->Parent = Read_object_no(file);
							break;

					case PAGETREE_KIDS:
							page_tree->kids = read_Page_tree(file, (long*)(&(page_tree->Count)));

							if(page_tree->max_to_load>0 && info->pages==NULL)								
									info->pages = calloc(page_tree->max_to_load, sizeof (struct PDF_PageTree));

							if(info->pages!=NULL)
								{
								i = 0;
								while(i<page_tree->Count)
									{
									read_page_tree_node(info, (int)page_tree->kids[i].page_no, (int)page_tree->Count, NULL);		/*	page_tree->kids);	*/
									i++;
									}
								}
							else
								{
								pagetree_kids_pos = file->actual_pos - strlen(pagetree_commands[PAGETREE_KIDS-1]);
								i=-1;
								}
							
							if(i==-2)
								{
								if(info->pages==NULL)
									info->pages = calloc(page_tree->max_to_load, sizeof (struct PDF_PageTree));

								if(info->pages->max_to_load==0)
										info->pages->max_to_load=page_tree->max_to_load;

								while(i<page_tree->Count)
									{
									read_page_tree_node(info, (int)page_tree->kids[i].page_no, (int)page_tree->Count, NULL);		/*	page_tree->kids);	*/
									i++;
									}
								i = 0;
								}
							break;

					case PAGETREE_COUNT:
							page_tree->max_to_load = (int)Read_object_no(file);

							if(i==-1 && info->pages==NULL)
								{
								if(info->pages==NULL)
									info->pages = calloc(page_tree->max_to_load, sizeof (struct PDF_PageTree));

								if(info->pages->max_to_load==0)
										info->pages->max_to_load=page_tree->max_to_load;

								if(pagetree_kids_pos!=0)
									{
									file->actual_pos = pagetree_kids_pos;
									pagetree_kids_pos = 0;
									break;
									}

								i = 0;
								while(i<page_tree->Count)
									{
									read_page_tree_node(info, (int)page_tree->kids[i].page_no, (int)page_tree->Count, NULL);		/*	page_tree->kids);	*/
									i++;
									}
								}
							else
								i=-2;
							break;

					case PAGETREE_ID:
							strcpy(page_tree->ID, Read_text(file));
							break;

					case PAGETREE_KIDS_Resources:
							page_tree->Resources = file->actual_pos;		/*	Read_object_no(file);	*/
							break;

					case PAGETREE_KIDS_MediaBox:
							if((rect=Read_rectangle(file))!=NULL)
								{
								if(info->pages)
									memcpy(&info->pages->MediaBox, rect, sizeof(struct Rectangle));								

								memcpy(&page_tree->MediaBox, rect, sizeof(struct Rectangle));
								free(rect);
								}
							break;

					case PAGETREE_KIDS_CropBox:
							page_tree->CropBox = file->actual_pos;		/*	Read_rectangle(file);	*/
							break;

					case PAGETREE_KIDS_BleedBox:
							page_tree->BleedBox = file->actual_pos;		/*	Read_rectangle(file);	*/
							break;

					case PAGETREE_KIDS_TrimBox:
							page_tree->TrimBox = file->actual_pos;		/*	Read_rectangle(file);	*/
							break;

					case PAGETREE_KIDS_ArtBox:
							page_tree->ArtBox = file->actual_pos;		/*	Read_rectangle(file);	*/
							break;

					case PAGETREE_KIDS_Contents:
							page_tree->Contents = file->actual_pos;			/*	Required - so, when this entry is present it means that it's the final object	*/
							break;

					case PAGETREE_KIDS_Rotate:
							page_tree->Rotate = (int)Read_object_no(file);
							break;

					case PAGETREE_KIDS_Thumb:
/*							page_tree->Thumb = Read_object_no(file);
							if((options.work_mode&LOAD_THUMBNAIL)!=0 && page_tree->Thumb>0)
								read_thumbnails(info, (int)page_tree->Thumb, &page_tree->thumb);			/* CHECK THIS!!!!	*/
							Add_entry2steps(STEPS_THUMB);
*/
							break;

					case PAGETREE_KIDS_B:
							page_tree->B = read_Page_tree(file, NULL);				/* How to handle this later????
																																	 See example: threads(2).pdf	*/
							break;

					case PAGETREE_KIDS_Dur:
							page_tree->Dur = (int)Read_object_no(file);
							break;

					case PAGETREE_KIDS_Trans:
							page_tree->Trans = Read_object_no(file);
							break;

					case PAGETREE_KIDS_Annots:
							page_tree->Annots = file->actual_pos;
							Add_entry2steps(STEPS_ANNOT);
																										/* TO DO !!!!!!!!!	*/
							break;

					case PAGETREE_KIDS_AA:
							page_tree->AA = Read_object_no(file);
							break;
	
					case PAGETREE_KIDS_PieceInfo:
							page_tree->PieceInfo = Read_object_no(file);
							break;
	
					case PAGETREE_KIDS_LastModified:
							line = Read_text(file);
							if(line)
								{
								strcpy (buf, line);
								Depack_date (buf);
								if ((page_tree->LastModified = malloc (strlen (line) + 1)) > 0L)
									strcpy (page_tree->LastModified, line);
								}
							break;

					case PAGETREE_KIDS_StructParents:
							page_tree->StructParents = (int)Read_object_no(file);
							break;

					case PAGETREE_KIDS_PZ:
							page_tree->PZ = (int)Read_object_no(file);
							break;

					case PAGETREE_KIDS_SeparationInfo:
							page_tree->SeparationInfo = Read_object_no(file);
							break;

					default:
									break;
					}
				}
			}
		}

/*	if(page_tree->Annots)
		Load_annotations(info, page_tree);	*/

	if(page_tree->Contents>0)										/* Is it the final object or is it just a list of objects?	*/
		{
		page_tree->max_to_load = info->pages->max_to_load;
		memcpy(&info->pages[info->pages->already_loaded], page_tree, sizeof (struct PDF_PageTree));

		info->pages->already_loaded = (int)(already_loaded+1);
		info->pages->real_number = info->pages->already_loaded;

		if(page_tree->max_to_load<info->pages->already_loaded)
			page_tree->max_to_load=info->pages->already_loaded;

		if(info->pages->max_to_load==0)
			info->pages->max_to_load=how_many;

		if(info->pages->max_to_load>info->pages->already_loaded)
			Change_status(STATUS_BAR2_UPDATE, info->pages->already_loaded, info->pages->max_to_load);
		}

	if(info->pages)
		{
		if(info->pages->max_to_load<info->pages->already_loaded)
			info->pages->max_to_load=info->pages->already_loaded;
		}

	GoBack(info);
	if(page_tree->kids)
		free(page_tree->kids);
	free(page_tree);
	return(NULL);
}


struct PDF_PageTree *find_page_tree(struct PDF_Info *info, struct PDF_PageTree *page, int page_no, int max)
	{
	max=max;
	page=page;
	return(&info->pages[page_no-1]);
	}


int find_page_no_by_contents(struct PDF_Info *info, size_t Contents)
	{
	int i=0;

	for(i=0; i<info->pages->max_to_load; i++)
		{
		if(info->pages[i].Contents==Contents)
			return(i+1);
		}
	return((int)info->page_no);
	}