#include	<mgem.h>
#include	<portab.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<tos.h>
#include	<ctype.h>
#include	<x_gem.h>
#include	"memdebug.h"
#include	"mp_const.h"
#include	"typespdf.h"
#include	"info_pdf.h"
#include	"files.h"
#include	"status.h"
#include	"options.h"
#include	"mypdf.h"


char *Read_command(struct files_pdf *);
char *read_command(int );
int Command2ID(struct files_pdf *, char **);
char *Read_type(struct files_pdf *);
unsigned long Read_object_no(struct files_pdf *);
int read_object_no(int );
char *Read_last_line(struct files_pdf *);
char *Read_line(struct files_pdf *);
char *Read_prev_line(struct files_pdf *);
char *read_prev_line(int );
long find_object_number (struct file_position *, int , unsigned int );
BOOLEAN load_objects(struct files_pdf);
BOOLEAN Load_objects(struct PDF_Info *, int);
int find_command(char **, char *);

BOOLEAN GoToObject(struct PDF_Info *, unsigned int );
BOOLEAN GoBack(struct PDF_Info *);

void Add_entry2steps(int value);

struct PDF_Outline *read_outline(struct PDF_Info *);
struct PDF_Threads *read_thread(struct PDF_Info *);
struct PDF_PageTree *read_page_tree_node(struct PDF_Info *, int , int , struct Page_tree *);
struct page_labels *read_page_labels(struct PDF_Info *);
BOOLEAN Load_NameTree(struct PDF_Info *, unsigned long );

extern OBJECT *adr_desktop, *adr_menu, *adr_toolbar, *adr_doc_info, *adr_status, *adr_strings, *adr_popup_menu, *adr_thread_sample, *adr_popup_zoom, *adr_popup_outline;
extern OBJECT *adr_steps;

extern struct opt options;
extern short wh_status;
extern X_GEM_INFO *x_gem;
extern WIND_LIST windows[];


extern char *types_command[];

char *root_commands[]={
		"/Type",
		"/Pages",
		"/PageLabels",
		"/Names",
		"/Dests",
		"/ViewerPreferences",
		"/PageLayout",
		"/PageMode",
		"/Outlines",
		"/Threads",
		"/OpenAction",
		"/URI",
		"/AcroForm",
		"/StructTreeRoot",
		"/SpiderInfo",
		"/JT",
		"/SPI:PageMap",
		NULL};

char *page_types[]={
	"/SinglePage",
	"/OneColumn",
	"/TwoColumnLeft",
	"/TwoColumnRight",
	NULL};

char *page_mode_types[]={
	"/UseNone",
	"/UseOutlines",
	"/UseThumbs",
	"/FullScreen",
	NULL};


struct Root_obj *read_root_obj(struct PDF_Info *info)
	{
	struct PDF_Trailer *trailer=info->trailer;
	struct files_pdf *file=info->file_info;
	char *line;
	struct Root_obj *root_obj=NULL;
	int keep_going=1;

	GoToObject(info, (unsigned int)trailer->Root_object);

	root_obj = calloc (1, sizeof (struct Root_obj));

	if(trailer)
	{
		line = Read_line(file);

		if(strstr(line, "obj")!=NULL)
			{
				while(keep_going!=0)
				{
				switch((keep_going=Command2ID(file, root_commands)))
					{
					case ROOT_TYPE:
								root_obj->Type = Command2ID(file, types_command);
								break;
					case ROOT_PAGES:
								root_obj->Pages = (unsigned int)Read_object_no(file);
								Add_entry2steps(STEPS_PAGETREE);
								break;
					case ROOT_PAGELAB:
								root_obj->PageLabels = (unsigned int)Read_object_no(file);
								Add_entry2steps(STEPS_LABELS);
								break;
					case ROOT_NAMES:
								root_obj->Names = (unsigned int)Read_object_no(file);
								Add_entry2steps(STEPS_NAMES);
								break;
					case ROOT_DESTS:
								break;
					case ROOT_VIEWPREF:
								break;
					case ROOT_PAGELAY:
								info->PageType = Command2ID(file, page_types);
								break;
					case ROOT_PAGEMODE:
								info->PageMode = Command2ID(file, page_mode_types);
								break;
					case ROOT_OUTLINES:
								root_obj->Outlines = (unsigned int)Read_object_no(file);		/* Number of the object, where Outlines are stored						*/
								Add_entry2steps(STEPS_OUTLINE);
								break;
					case ROOT_THREADS:
								root_obj->Threads = (unsigned int)Read_object_no(file);
								Add_entry2steps(STEPS_THREAD);
								break;
					case ROOT_OPENACT:
								break;
					case ROOT_URI:
								break;
					case ROOT_ACROFORM:
								break;
					case ROOT_STRTREEROOT:
								break;
					case ROOT_SPIDERINFO:
								break;
					case ROOT_JT:
								break;
					case ROOT_SPIPAGEMAP:
								root_obj->SPIPageMap = Read_object_no(file);
								break;
					default:
								break;
					}
				}
			}

		info->Root_obj = root_obj;

		if(root_obj->Names)
		{
		Change_status(STATUS_BAR1_UPDATE, STATUS_PDF_NAMETREE, 0);
		Load_NameTree(info, root_obj->Names);
		Change_status(STATUS_BAR3_UPDATE, STATUS_PDF_NAMETREE, 0);
		}

		if(root_obj->PageLabels)
		{
		Change_status(STATUS_BAR1_UPDATE, STATUS_PDF_PAGE_LABELING, 0);
		read_page_labels(info);			/* Load the PageLabels	*/
		Change_status(STATUS_BAR3_UPDATE, STATUS_PDF_PAGE_LABELING, 0);
		}

		if(root_obj->Outlines>0)
		{
			Change_status(STATUS_BAR1_UPDATE, STATUS_PDF_OUTLINE, 0);
			info->Root_obj = root_obj;
			info->Outline = read_outline(info);			/* Read the outline of the document	*/
			Change_status(STATUS_BAR3_UPDATE, STATUS_PDF_OUTLINE, 0);
		}

		if(root_obj->Threads>0)
		{
			info->Root_obj = root_obj;
			if(options.work_mode&LOAD_THREADS)
			{
				Change_status(STATUS_BAR1_UPDATE, STATUS_PDF_ARTICLE_THREADS, 0);
				info->Threads = read_thread(info);			/* Read the article threads of the document	*/
				if(info->Threads!=NULL)
					adr_popup_menu[POPUP_M_THREADS].ob_state &= ~DISABLED;
				Change_status(STATUS_BAR3_UPDATE, STATUS_PDF_ARTICLE_THREADS, 0);
			}
		}

		if(root_obj->Pages>0 && options.work_mode&LOAD_PAGETRE)
		{
			Change_status(STATUS_BAR1_UPDATE, STATUS_PDF_PAGE_TREE, 0);
			read_page_tree_node(info, (unsigned int)root_obj->Pages, 0, NULL);
			Change_status(STATUS_BAR3_UPDATE, STATUS_PDF_PAGE_TREE, 0);
		}

	}
	GoBack(info);
	return(root_obj);
}
