#define PROTECT_BIT_PRINT	3			/* Print document	*/
#define PROTECT_BIT_MODIFY	4		/* Modify contents of document (other than text annotations and
																	interactive form fields)	*/
#define PROTECT_BIT_COPY	5			/* Copy text and graphics from document	*/
#define PROTECT_BIT_ADD		6			/* Add or modify text annotations and interactive form fields	*/

#define PROTECT_PRINT		1<<PROTECT_BIT_PRINT
#define PROTECT_MODIFY	1<<PROTECT_BIT_MODIFY
#define PROTECT_COPY		1<<PROTECT_BIT_COPY
#define PROTECT_ADD			1<<PROTECT_BIT_ADD


#define FILTER			1
#define ALGORITHM		2
#define REV_NUM			3
#define USER_PASS		4
#define FIX_STR			5
#define PROTECTION		6

struct Encryption
{
	int filter;								/* '/Filter' Type of the the filter	*/
/*	char Filter[32];					/* '/Filter' Type of the the filter	*/	*/
	int algorithm;						/* '/V' Type of the algorithm: 0 or 1	*/
	int rev_num;							/* '/R' Revision number		*/
	char user_password[32];		/* '/O' (Required) A 32-byte string used in determining whether a valid owner password was
																entered. Contains an encrypted version of the padded user password (see step 1 of
																Algorithm 3.2 below).	*/
	char fixed_string[32];		/* '/U' (Required) A 32-byte string used in determining whether a valid user password was
																entered. Contains an encrypted version of the fixed padding string shown in step 1 of
																Algorithm 3.2 below.	*/
	int protection;						/* '/P' (Required) A set of flags specifying which operations are permitted when the document is
																opened with the user password (see Table 3.14).	*/
};

struct Encryption *read_encryption (struct PDF_Info *, int);


/* Example
27 0 obj
<< 
/Filter /Standard 
/V 1 
/R 2 
/O (encrypted string)
/U (encrypted string)
/P 65472 
>> 
*/