#include	<ext.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>
#include	<x_gem.h>
#include	"files.h"
#include	"typespdf.h"
#include	"options.h"
#include	"info_pdf.h"
#include	"mypdf.h"
#include	"mp_const.h"

extern struct PDF_Info *root_pdf_info;

char *last_10_files[10];
struct opt options;
extern X_GEM_INFO *x_gem;
extern OBJECT *adr_menu, *adr_last_files, *adr_strings;

extern OBJECT *adr_options, *adr_popup_lang, *adr_popup_work, *adr_popup_date, *adr_popup_units, *adr_popup_dither;

#define ULONG		unsigned long

int wind_options_handle;

void Default_options(void);
ULONG	DHST_init( ULONG );
void redraw_icon_form (short );
void close_options_form (short );


void *Free_and_alloc(void *block, unsigned long size)
	{
	if(block)
		free(block);
	if(size!=0)
		return(calloc(1, size));
	else
		return(NULL);
	}


void Free_last_10_files(void)
	{
	int i=0;

	for(i=0; i<10; i++)
		if(last_10_files[i]!=NULL)
			free(last_10_files[i]);
	}

void add_file_to_list(char *name)						/* This routine should be somewhere else. Maybe in utils.c or so ???		*/
	{
	char buf[256]={0};
	int i=0;

	adr_last_files[0].ob_height = 0;					/* The submenu has zero height			*/
	if(options.last_files==10)								/* Are there 10 files in memory?		*/
		{
		for(i=0; i<9; i++)											/* Let's move all files up 1 entry	*/
			{
			if(strlen(last_10_files[i+1])>strlen(last_10_files[i]))			/* First we have to free the memory		*/
				{
				free(last_10_files[i]);		last_10_files[i]=NULL;
				last_10_files[i] = calloc(1, strlen(last_10_files[i+1]));
				}
			memset(last_10_files[i], 0, strlen(last_10_files[i]));
			strcpy(last_10_files[i], last_10_files[i+1]);								/* Now we have to copy the next entry to the actual	*/
			strcpy(buf, last_10_files[i]);
			x_cut_filename (buf);
			x_set_ob_text (adr_last_files, LAST_FILES_0 + i, buf);			/* Put the filename in the submenu									*/
			adr_last_files[0].ob_height += adr_last_files[LAST_FILES_0].ob_height;	/* Change the submenu height						*/
			}
		options.last_files--;
		free(last_10_files[options.last_files]);											/* Free the last entry															*/
		last_10_files[options.last_files] = NULL;
		adr_last_files[0].ob_height += adr_last_files[LAST_FILES_0].ob_height;
		}
	else
		{
	adr_last_files[0].ob_height = (options.last_files+1)*adr_last_files[LAST_FILES_0].ob_height;
		}

	last_10_files[options.last_files] = calloc(1, strlen(name)+10);	/* Malloc memory for the last entry									*/
	strcpy(last_10_files[options.last_files], name);								/* Copy the entry in memory													*/
	strcpy(buf, name);
	x_cut_filename (buf);
	x_set_ob_text (adr_last_files, LAST_FILES_0 + options.last_files, buf);
	adr_last_files[LAST_FILES_0 + options.last_files].ob_state &= ~DISABLED;
	if(options.last_files<10)
		options.last_files++;
	menu_ienable (adr_menu, M_LAST_FILES, 1);
	}


void Load_options(void)
	{
	X_COOKIE *cookie1=NULL, *cookie2=NULL;
	int handle=0, i=0, i2=0;
	unsigned long templ=0L;
	char path[256]={0}, min[5]={0}, act[5]={0};

	wind_options_handle = -1;

	options.ava_mem = (unsigned long)Malloc(-1);


	cookie1 = vq_cookie ('MWHL');

	cookie1 = vq_cookie ('MagX');
	cookie2 = vq_cookie ('MiNT');

	path[0] = 'a'+Dgetdrv();
	strcat(path, ":");
	Dgetpath(&path[2], 0);
	strcat(&path[0], "\\");

	if(cookie1!=NULL || cookie2!=NULL)
		{																/* CHANGE TO /HOME DIRECTORY	*/
		strcat(path, "MyPDF.CFG");
		}
	else
		strcat(path, "MyPDF.CFG");

	handle = open(path, O_RDONLY);
	if(handle>0)
		{
		read(handle, &templ, 4);
		if(templ!='APDF')
			goto end;
		read(handle, &templ, 4);
		if(templ!='VERA')
			goto end;
		read(handle, &act[0], 4);			/* Actual version number	*/

		read(handle, &templ, 4);
		if(templ!='VERM')
			goto end;

		read(handle, &min[0], 4);
		if(atoi(&act[0])<atoi(MIN_VERS))
			{															/* Display an alert!!!!	*/
			x_gem_alert("[3][Old configuration file.|I will use the defualt|settings][Ok]", 0L);
			Default_options();
			goto end;
			}

		read(handle, &templ, 4);
		if(templ!='HEAD')
			goto end;
		read(handle, &templ, 4);
		Fseek(0, handle, 1);
		read(handle, &options, templ);		/*atoi(&temp[0]));*/
		Fseek(0, handle, 1);
		
		read(handle, &templ, 4);
		Fseek(0, handle, 1);
		if(templ!='PATH')
			goto end;
		templ=0;
		read(handle, &i2, 2);
		if(options.paths.app_dir!=NULL)
			free(options.paths.app_dir);
		options.paths.app_dir = calloc(1, i2+5); 
		read(handle, options.paths.app_dir, i2);
		read(handle, &i2, 2);
		if(options.paths.default_pdf_dir!=NULL)
			free(options.paths.default_pdf_dir);
		options.paths.default_pdf_dir = calloc(1, i2+5); 
		read(handle, options.paths.default_pdf_dir, i2);

		read(handle, &i2, 2);
		if(options.paths.cache!=NULL)
			free(options.paths.cache);
		options.paths.cache = calloc(1, i2+5); 
		read(handle, options.paths.cache, i2);
		
		read(handle, &templ, 4);
		if(templ!='LAST')
			goto end;
		menu_ienable (adr_menu, M_LAST_FILES, 1);
		adr_last_files[0].ob_height = 0;
		for(i=0; i<options.last_files; i++)
			{
			read(handle, &templ, 4);
			read(handle, &path[0], templ);

			last_10_files[i] = malloc(strlen(&path[0]));
			strcpy(last_10_files[i], &path[0]);
			x_cut_filename (&path[0]);
			x_set_ob_text (adr_last_files, LAST_FILES_0 + i, &path[0]);
			adr_last_files[LAST_FILES_0 + i].ob_state &= ~DISABLED;
			adr_last_files[0].ob_height += adr_last_files[LAST_FILES_0].ob_height;
			memset(&path[0], 0, strlen(last_10_files[i])+1);
			}

		close(handle);
		}
	else
		Default_options();

	if(DHST_init( x_gem->ap_id ))
		options.system.protocols = PROT_DHST;

end:
	if(handle>0)
		close(handle);
	}


void Save_options(BOOLEAN quit)
	{
	X_COOKIE *cookie1=NULL, *cookie2=NULL;
	char temp[256]={0};
	char path[256]={0};
	int handle=0, i=0, i2=0;
	unsigned long ii=0;

	quit=quit;

	cookie1 = vq_cookie ('MagX');
	cookie2 = vq_cookie ('MiNT');

	if(cookie1!=NULL || cookie2!=NULL)
		{												/* CHANGE TO /HOME DIRECTORY	*/
		strcpy(path, "MyPDF.CFG");
		}
	else
		{
		strcpy(path, "MyPDF.CFG");
		}

	handle = creat (path);
	if (handle > 0)
	{
		write(handle, "APDF", 4);
		write(handle, "VERA", 4);
		write(handle, ACT_VERS, 4);
		write(handle, "VERM", 4);
		write(handle, MIN_VERS, 4);

		write(handle, "HEAD", 4);
		itoa((int)(sizeof(struct opt)-sizeof(struct pat)-sizeof(struct sys)), &temp[0], (int)10);
		ii = (sizeof(struct opt)-sizeof(struct pat)-sizeof(struct sys));
		write(handle, &ii, 4);
		write(handle, &options, sizeof(struct opt)-sizeof(struct pat)-sizeof(struct sys));


				/* PATHS	*/
		write(handle, "PATH", 4);
		i2=(int)strlen(options.paths.app_dir);
		write(handle, &i2, 2);
		write(handle, options.paths.app_dir, i2);

		i2=(int)strlen(options.paths.default_pdf_dir);
		write(handle, &i2, 2);
		write(handle, options.paths.default_pdf_dir, i2);

		i2=(int)strlen(options.paths.cache);
		write(handle, &i2, 2);
		write(handle, options.paths.cache, i2);


		if(options.last_files>0)				/* LAST OPENED FILES	*/
			{
			write(handle, "LAST", 4);
		/*	i2 = options.last_files;
			write(handle, &i2, 2);	*/
			for(i=0; i<options.last_files; i++)
			{
				ii = strlen(last_10_files[i])+1;
				write(handle, &ii, 4);
				write(handle, last_10_files[i], ii);
				memset(&temp[0], 0, 10);
			}
		}

		close(handle);
	}
}


void Default_options(void)
	{
	int i=0;
	char paths[256]={0};
	root_pdf_info = NULL;

	wind_options_handle = -1;

	options.per_mem = 100;									/* We can use 100% of memory	*/
	options.max_mem = 9000000L;							/* Maximal amount of memory for MyPDF		*/
	options.max_memory = TRUE;
	options.date_type = 0;									/* dd.mm.yyyy 													*/
	options.language = 0;										/* English															*/
	options.work_mode = LOAD_TRAILER|LOAD_ENCRYPT|LOAD_ROOTOBJ|LOAD_THREADS|LOAD_PAGETRE|LOAD_OUTLINE|LOAD_THUMBNAIL;			/* Loads all objects */
	options.usu = 1;												/* cm																		*/
	options.log = LOG_YES_DEL;							/* Save all log infos in the new file		*/
	options.autosave = TRUE;								/* Autosave options											*/
	options.paths.fonts = NULL;
	options.paths.logs = NULL;
	options.last_files = 0;
	for(i=0; i<10; i++)
		last_10_files[i] = NULL;

	options.paths.app_dir = calloc(1, 256);
	options.paths.app_dir[0] = 'a'+Dgetdrv();
	strcat(options.paths.app_dir, ":");
	Dgetpath(&paths[0], 0);
	strcat(options.paths.app_dir, strlwr(&paths[0]));
	strcat(options.paths.app_dir, "\\");
	strcat(options.paths.app_dir, "mypdf.app");

	options.history |= HISTORY_ZOOM;
	options.history |= HISTORY_SLIDER;
	options.history |= HISTORY_PAGES;

	options.use_cache = FALSE;

	options.bubble_help = TRUE;
	options.bubble_time = 1000;

	options.paths.default_pdf_dir = calloc(1, strlen(options.paths.app_dir));
	strcpy(options.paths.default_pdf_dir, options.paths.app_dir);
	x_cut_dirname(options.paths.default_pdf_dir);

	if(options.paths.cache==NULL)
		{
		char name[256]={0};
		name[0] = Dgetdrv()+'A';
		name[1] = ':';
		Dgetpath(&name[2], Dgetdrv());
		strcat(name, "\\cache\\");
		options.paths.cache = calloc(1, strlen(name));
		strcpy(options.paths.cache, name);
		}

	options.system.protocols = 0;

	options.show_debug.bar = TRUE;
	options.show_debug.steps = TRUE;
	options.show_debug.memory = TRUE;
	options.dithering_method = 0;			/* Nearest color	*/

	if(DHST_init( x_gem->ap_id ))
		options.system.protocols = PROT_DHST;
	}



void do_options_popup(int window, int popup_type, OBJECT *adr_popup, int max_value, int *value, int output_text, int output_cycle)
	{
	OBJECT adr2, *adr=NULL;
	WIND_LIST *wind;
	char dummy[256]={0};
	int prev_val=*value;

	wind = &x_gem->wind[window];
	adr = wind->w_dial.d_addr;

	if(adr==NULL)
		return;

	if(popup_type==0)				/* Text button	*/
		{
		x_pop_up (x_gem->mx-(0.5*adr_popup->ob_width), x_gem->my, adr_popup, &adr2, (short*)value);
		if((*value)>0)
			{
			if(output_text==OPTIONS_UNITS_TE)
				{
				strncpy(dummy, x_get_ob_text(adr_popup, *value), strlen(x_get_ob_text(adr_popup, *value))); /*strcspn(x_get_ob_text(adr_popup, *value), " "));*/
				x_set_ob_text(adr, output_text, dummy);
				}
			else
				x_set_ob_text(adr, output_text, x_get_ob_text(adr_popup, *value));
			}
		else
			*value = prev_val;

		adr[output_text].ob_state &= ~SELECTED;
		s_objc_draw (adr, output_text, MAX_DEPTH, &x_gem->desk_size);
		}
	else										/* Cycle button	*/
		{
		if((*value)<max_value)
			(*value)++;
		else
			(*value)=1;

		s_objc_draw (adr, output_cycle, MAX_DEPTH, &x_gem->desk_size);
		evnt_timer (100L);

		if(output_text==OPTIONS_UNITS_TE)
			{
			strncpy(dummy, x_get_ob_text(adr_popup, *value), strcspn(x_get_ob_text(adr_popup, *value), " "));
			x_set_ob_text(adr, output_text, dummy);
			}
		else
			x_set_ob_text(adr, output_text, x_get_ob_text(adr_popup, *value));

		adr[output_cycle].ob_state &= ~SELECTED;
		s_objc_draw (adr, output_cycle, MAX_DEPTH, &x_gem->desk_size);
		s_objc_draw (adr, output_text, MAX_DEPTH, &x_gem->desk_size);
		}
	}


static short per_mem, units, date, lang, work, dither;
static unsigned long max_mem;

void open_options_dialog(void)
	{
	short i;
	unsigned long max_max_mem=(unsigned long)Malloc(-1);
	char dummy[256]={0};
	int working_modes[]={
	LOAD_TRAILER|LOAD_ENCRYPT|LOAD_ROOTOBJ|LOAD_THREADS|LOAD_PAGETRE|LOAD_OUTLINE|LOAD_THUMBNAIL|LOAD_TEXT|LOAD_VECTOR|LOAD_BITMAP,
	LOAD_TRAILER|LOAD_ENCRYPT|LOAD_ROOTOBJ|LOAD_THREADS|LOAD_PAGETRE|LOAD_OUTLINE|LOAD_THUMBNAIL|LOAD_TEXT|LOAD_VECTOR|LOAD_BITMAP|LOAD_ANTIALIAS,
	LOAD_TRAILER|LOAD_ENCRYPT|LOAD_ROOTOBJ|LOAD_THREADS|LOAD_PAGETRE|LOAD_OUTLINE|LOAD_THUMBNAIL|LOAD_TEXT|LOAD_ANTIALIAS,
	LOAD_TRAILER|LOAD_ENCRYPT|LOAD_ROOTOBJ|LOAD_THREADS|LOAD_PAGETRE|LOAD_OUTLINE|LOAD_THUMBNAIL|LOAD_TEXT|LOAD_VECTOR|LOAD_ANTIALIAS,
	LOAD_TRAILER|LOAD_ENCRYPT|LOAD_ROOTOBJ|LOAD_THREADS|LOAD_PAGETRE|LOAD_OUTLINE|LOAD_THUMBNAIL|LOAD_TEXT|LOAD_BITMAP|LOAD_ANTIALIAS,
	LOAD_TRAILER|LOAD_ENCRYPT|LOAD_ROOTOBJ|LOAD_THREADS|LOAD_PAGETRE|LOAD_OUTLINE|LOAD_THUMBNAIL|LOAD_TEXT,
	LOAD_TRAILER|LOAD_ENCRYPT|LOAD_ROOTOBJ|LOAD_THREADS|LOAD_PAGETRE|LOAD_OUTLINE|LOAD_THUMBNAIL|LOAD_VECTOR|LOAD_BITMAP|LOAD_ANTIALIAS,
	-1
	};
	
	per_mem = options.per_mem;
	max_mem = options.max_mem;
	units = options.usu + 1;
	date = options.date_type + 1;
	lang = options.language + 1;
	dither = options.dithering_method + 1;

	for(i=0; working_modes[i]!=-1; i++)
		{
		if(options.work_mode==working_modes[i])
			{
			work = i+1;
			break;
			}
		}
	ltoa((max_mem/1000), x_get_ob_text(adr_options, OPTIONS_MAX_TEXT), 10);
	itoa(per_mem, x_get_ob_text(adr_options, OPTIONS_PER_TEXT), 10);

	x_set_ob_text(adr_options, OPTIONS_DATE_TE, x_get_ob_text(adr_popup_date, date));
	x_set_ob_text(adr_options, OPTIONS_LANG_TE, x_get_ob_text(adr_popup_lang, lang));
	x_set_ob_text(adr_options, OPTIONS_WORK_TE, x_get_ob_text(adr_popup_work, work));

	strncpy(dummy, x_get_ob_text(adr_popup_units, units), strcspn(x_get_ob_text(adr_popup_units, units), " "));
	x_set_ob_text(adr_options, OPTIONS_UNITS_TE, dummy);

	if(options.history&HISTORY_ZOOM)
		adr_options[OPTIONS_HIS_ZOOM].ob_state |= SELECTED;
	else
		adr_options[OPTIONS_HIS_ZOOM].ob_state &= ~SELECTED;
	if(options.history&HISTORY_SLIDER)
		adr_options[OPTIONS_HIS_SLID].ob_state |= SELECTED;
	else
		adr_options[OPTIONS_HIS_SLID].ob_state &= ~SELECTED;
	if(options.history&HISTORY_PAGES)
		adr_options[OPTIONS_HIS_PAGE].ob_state |= SELECTED;
	else
		adr_options[OPTIONS_HIS_PAGE].ob_state &= ~SELECTED;


	if(options.autosave==1)
		adr_options[OPTIONS_AUTO_OPT].ob_state |= SELECTED;
	else
		adr_options[OPTIONS_AUTO_OPT].ob_state &= ~SELECTED;

	if(options.max_memory==TRUE)
		{
		adr_options[OPTIONS_MAX_US].ob_state |= SELECTED;
		adr_options[OPTIONS_PER_US].ob_state &= ~SELECTED;
		}
	else
		{
		adr_options[OPTIONS_MAX_US].ob_state &= ~SELECTED;
		adr_options[OPTIONS_PER_US].ob_state |= SELECTED;
		}

	if(options.bubble_help==TRUE)
		adr_options[OPTIONS_BUBBLE].ob_state |= SELECTED;
	else
		adr_options[OPTIONS_BUBBLE].ob_state &= ~SELECTED;


	if(options.bubble_time==-1)
		{
		adr_options[OPTIONS_TIME_CHK].ob_state &= ~SELECTED;
		adr_options[OPTIONS_RIGHT].ob_state |= SELECTED;
		}
	else
		{
		adr_options[OPTIONS_TIME_CHK].ob_state |= SELECTED;
		adr_options[OPTIONS_RIGHT].ob_state &= ~SELECTED;
		itoa(options.bubble_time, x_get_ob_text(adr_options, OPTIONS_TIME_TXT), 10);
		}

	if(options.bubble_help==FALSE)
		{
		adr_options[OPTIONS_TIME_CHK].ob_state |= DISABLED;
		adr_options[OPTIONS_TIME_TXT].ob_state |= DISABLED;
		adr_options[OPTIONS_MS].ob_state |= DISABLED;
		adr_options[OPTIONS_RIGHT].ob_state |= DISABLED;
		}
	else
		{
		adr_options[OPTIONS_TIME_CHK].ob_state &= ~DISABLED;
		adr_options[OPTIONS_TIME_TXT].ob_state &= ~DISABLED;
		adr_options[OPTIONS_TIME_TXT].ob_flags |= EDITABLE;
		adr_options[OPTIONS_MS].ob_state &= ~DISABLED;
		adr_options[OPTIONS_RIGHT].ob_state &= ~DISABLED;
		}
	
	if(options.show_debug.bar == TRUE)
		adr_options[OPTIONS_BARS].ob_state |= SELECTED;
	else
		adr_options[OPTIONS_BARS].ob_state &= ~SELECTED;
	if(options.show_debug.steps == TRUE)
		adr_options[OPTIONS_STEPS].ob_state |= SELECTED;
	else
		adr_options[OPTIONS_STEPS].ob_state &= ~SELECTED;
	if(options.show_debug.memory == TRUE)
		adr_options[OPTIONS_MEMORY].ob_state |= SELECTED;
	else
		adr_options[OPTIONS_MEMORY].ob_state &= ~SELECTED;

	strncpy(dummy, x_get_ob_text(adr_popup_dither, dither), strlen(x_get_ob_text(adr_popup_dither, dither)));
	x_set_ob_text(adr_options, OPTIONS_DITH_TE, dummy);


	if(options.use_cache == TRUE)
		adr_options[OPTIONS_USE_CACH].ob_state |= SELECTED;
	else
		adr_options[OPTIONS_USE_CACH].ob_state &= ~SELECTED;
	x_set_ob_text(adr_options, OPTIONS_CACHE_PA, options.paths.cache);

	if (wind_options_handle < 0)
		wind_options_handle = x_open_wind (-1, -1, adr_options->ob_width - 1, adr_options->ob_height - 1, 0, 0, 1, 1, 1, 1, 0, 0, 1, 1, CLOSER|NAME|MOVER, "Options:", "", 0L, adr_options, NULL, 0L, 0L, (FNCP1)redraw_icon_form, (FNCP1)close_options_form, 0L);
	else
		wind_set (x_gem->wind[wind_options_handle].w_hand, WF_TOP, 0, 0, 0, 0);

	menu_tnormal (adr_menu, x_gem->event_buffer[3], 1);
	}



void take_options_from_window(int window)
	{
	WIND_LIST *wind;
	OBJECT *adr;
	int working_modes[]={
	LOAD_TRAILER|LOAD_ENCRYPT|LOAD_ROOTOBJ|LOAD_THREADS|LOAD_PAGETRE|LOAD_OUTLINE|LOAD_THUMBNAIL|LOAD_TEXT|LOAD_VECTOR|LOAD_BITMAP,
	LOAD_TRAILER|LOAD_ENCRYPT|LOAD_ROOTOBJ|LOAD_THREADS|LOAD_PAGETRE|LOAD_OUTLINE|LOAD_THUMBNAIL|LOAD_TEXT|LOAD_VECTOR|LOAD_BITMAP|LOAD_ANTIALIAS,
	LOAD_TRAILER|LOAD_ENCRYPT|LOAD_ROOTOBJ|LOAD_THREADS|LOAD_PAGETRE|LOAD_OUTLINE|LOAD_THUMBNAIL|LOAD_TEXT|LOAD_ANTIALIAS,
	LOAD_TRAILER|LOAD_ENCRYPT|LOAD_ROOTOBJ|LOAD_THREADS|LOAD_PAGETRE|LOAD_OUTLINE|LOAD_THUMBNAIL|LOAD_TEXT|LOAD_VECTOR|LOAD_ANTIALIAS,
	LOAD_TRAILER|LOAD_ENCRYPT|LOAD_ROOTOBJ|LOAD_THREADS|LOAD_PAGETRE|LOAD_OUTLINE|LOAD_THUMBNAIL|LOAD_TEXT|LOAD_BITMAP|LOAD_ANTIALIAS,
	LOAD_TRAILER|LOAD_ENCRYPT|LOAD_ROOTOBJ|LOAD_THREADS|LOAD_PAGETRE|LOAD_OUTLINE|LOAD_THUMBNAIL|LOAD_TEXT,
	LOAD_TRAILER|LOAD_ENCRYPT|LOAD_ROOTOBJ|LOAD_THREADS|LOAD_PAGETRE|LOAD_OUTLINE|LOAD_THUMBNAIL|LOAD_VECTOR|LOAD_BITMAP|LOAD_ANTIALIAS,
	-1
	};

	wind = &x_gem->wind[window];
	adr = wind->w_dial.d_addr;

	options.per_mem = per_mem;
	options.max_mem = max_mem;
	options.date_type = date-1;
	options.usu = units-1;
	options.language = lang-1;
	options.work_mode = working_modes[work-1];
	options.dithering_method = dither-1;

	if(adr[OPTIONS_AUTO_OPT].ob_state&SELECTED)
		options.autosave=1;
	else
		options.autosave=0;

	if(adr[OPTIONS_HIS_ZOOM].ob_state&SELECTED)
		options.history |= HISTORY_ZOOM;
	else
		options.history &= ~HISTORY_ZOOM;

	if(adr[OPTIONS_HIS_SLID].ob_state&SELECTED)
		options.history |= HISTORY_SLIDER;
	else
		options.history &= ~HISTORY_SLIDER;

	if(adr[OPTIONS_HIS_PAGE].ob_state&SELECTED)
		options.history |= HISTORY_PAGES;
	else
		options.history &= ~HISTORY_PAGES;

	if(adr[OPTIONS_BUBBLE].ob_state&SELECTED)
		options.bubble_help = TRUE;
	else
		options.bubble_help = FALSE;

	if(adr[OPTIONS_RIGHT].ob_state&SELECTED)
		options.bubble_time=-1;
	else
		options.bubble_time = atoi(x_get_ob_text (adr, OPTIONS_TIME_TXT));

	if(adr[OPTIONS_BARS].ob_state&SELECTED)
		options.show_debug.bar = TRUE;
	else
		options.show_debug.bar = FALSE;
	if(adr[OPTIONS_STEPS].ob_state&SELECTED)
		options.show_debug.steps = TRUE;
	else
		options.show_debug.steps = FALSE;
	if(adr[OPTIONS_MEMORY].ob_state&SELECTED)
		options.show_debug.memory = TRUE;
	else
		options.show_debug.memory = FALSE;

	if(adr[OPTIONS_USE_CACH].ob_state&SELECTED)
		options.use_cache = TRUE;
	else
		options.use_cache = FALSE;
	}


void handle_options_window(int obj)
	{
	WIND_LIST *wind;
	OBJECT *adr;
	unsigned long max_max_mem=(unsigned long)Malloc(-1);

	wind = &x_gem->wind[x_gem->event_wind];
	adr = wind->w_dial.d_addr;

	switch (obj)
		{
		case OPTIONS_OK:
			take_options_from_window(x_gem->event_wind);

			adr[obj].ob_state &= ~SELECTED;
			x_close_wind(wind_options_handle);
			break;

		case OPTIONS_APPLY:
			take_options_from_window(x_gem->event_wind);

			adr[obj].ob_state &= ~SELECTED;
			break;

		case OPTIONS_SAVE:
			take_options_from_window(x_gem->event_wind);

			Save_options(FALSE);
			adr[obj].ob_state &= ~SELECTED;
			break;

		case OPTIONS_CANCEL:
			adr[obj].ob_state &= ~SELECTED;
			x_close_wind(wind_options_handle);
			break;

		case OPTIONS_MAX_US:
			options.max_memory = TRUE;
			s_objc_draw (adr, OPTIONS_MAX_US, MAX_DEPTH, &x_gem->desk_size);
			break;

		case OPTIONS_PER_US:
			options.max_memory = FALSE;
			s_objc_draw (adr, OPTIONS_PER_US, MAX_DEPTH, &x_gem->desk_size);
			break;

		case OPTIONS_PER_LE:
			if (per_mem > 0)
			{
			if(options.max_memory==FALSE)
				{
				per_mem --;
				max_mem = per_mem*(options.ava_mem/100);
				itoa ((int)(max_mem/1000), x_get_ob_text (adr, OPTIONS_MAX_TEXT), 10);
				s_objc_draw (adr, OPTIONS_MAX_TEXT, MAX_DEPTH, &x_gem->desk_size);

				itoa (per_mem, x_get_ob_text (adr, OPTIONS_PER_TEXT), 10);
				s_objc_draw (adr, OPTIONS_PER_TEXT, MAX_DEPTH, &x_gem->desk_size);
				evnt_timer (100L);
				}
			}
			break;

		case OPTIONS_PER_RI:
			if (per_mem < 100)
			{
			if(options.max_memory==FALSE)
				{
				per_mem ++;
				max_mem = per_mem*(options.ava_mem/100);
				itoa ((int)(max_mem/1000), x_get_ob_text (adr, OPTIONS_MAX_TEXT), 10);
				s_objc_draw (adr, OPTIONS_MAX_TEXT, MAX_DEPTH, &x_gem->desk_size);

				itoa (per_mem, x_get_ob_text (adr, OPTIONS_PER_TEXT), 10);
				x_objc_draw (wind_options_handle, adr, OPTIONS_PER_TEXT, MAX_DEPTH, &x_gem->desk_size);
				s_objc_draw (adr, OPTIONS_PER_TEXT, MAX_DEPTH, &x_gem->desk_size);
				evnt_timer (100L);
				}
			}
			break;

		case OPTIONS_MAX_LE:
			if(options.max_memory==TRUE)
				{
				if (max_mem > 0)
					max_mem -= 1000;
				else
					max_mem = 0;
				itoa ((int)(max_mem/1000), x_get_ob_text (adr, OPTIONS_MAX_TEXT), 10);
				s_objc_draw (adr, OPTIONS_MAX_TEXT, MAX_DEPTH, &x_gem->desk_size);

				per_mem = 100*max_mem / options.ava_mem;
				itoa (per_mem, x_get_ob_text (adr, OPTIONS_PER_TEXT), 10);
				s_objc_draw (adr, OPTIONS_PER_TEXT, MAX_DEPTH, &x_gem->desk_size);

				evnt_timer (100L);
				}
			break;

		case OPTIONS_MAX_RI:
			if(options.max_memory==TRUE)
				{
				if (max_mem < (max_max_mem-1000))
					max_mem += 1000;
				else
					max_mem = max_max_mem;
				itoa ((int)(max_mem/1000), x_get_ob_text (adr, OPTIONS_MAX_TEXT), 10);
				s_objc_draw (adr, OPTIONS_MAX_TEXT, MAX_DEPTH, &x_gem->desk_size);

				per_mem = 100*max_mem / options.ava_mem;
				itoa (per_mem, x_get_ob_text (adr, OPTIONS_PER_TEXT), 10);
				s_objc_draw (adr, OPTIONS_PER_TEXT, MAX_DEPTH, &x_gem->desk_size);

				evnt_timer (100L);
				}
			break;

		case OPTIONS_UNITS_TE:
			do_options_popup(x_gem->event_wind, 0, adr_popup_units, POPUP_UNITS_PO, (int*)&units, OPTIONS_UNITS_TE, OPTIONS_UNITS_CY);
			break;
		case OPTIONS_UNITS_CY:
			do_options_popup(x_gem->event_wind, 1, adr_popup_units, POPUP_UNITS_PO, (int*)&units, OPTIONS_UNITS_TE, OPTIONS_UNITS_CY);
			break;
		case OPTIONS_DATE_TE:
			do_options_popup(x_gem->event_wind, 0, adr_popup_date, POPUP_DATE_2, (int*)&date, OPTIONS_DATE_TE, OPTIONS_DATE_CY);
			break;
		case OPTIONS_DATE_CY:
			do_options_popup(x_gem->event_wind, 1, adr_popup_date, POPUP_DATE_2, (int*)&date, OPTIONS_DATE_TE, OPTIONS_DATE_CY);
			break;

		case OPTIONS_LANG_TE:
			do_options_popup(x_gem->event_wind, 0, adr_popup_lang, POPUP_LANGUAGE_2, (int*)&lang, OPTIONS_LANG_TE, OPTIONS_LANG_CY);
			break;
		case OPTIONS_LANG_CY:
			do_options_popup(x_gem->event_wind, 1, adr_popup_lang, POPUP_LANGUAGE_2, (int*)&lang, OPTIONS_LANG_TE, OPTIONS_LANG_CY);
			break;

		case OPTIONS_WORK_TE:
			do_options_popup(x_gem->event_wind, 0, adr_popup_work, POPUP_WORK_2, (int*)&work, OPTIONS_WORK_TE, OPTIONS_WORK_CY);
			break;
		case OPTIONS_WORK_CY:
			do_options_popup(x_gem->event_wind, 1, adr_popup_work, POPUP_WORK_2, (int*)&work, OPTIONS_WORK_TE, OPTIONS_WORK_CY);
			break;

		case OPTIONS_DITH_TE:
			do_options_popup(x_gem->event_wind, 0, adr_popup_dither, POPUP_DITH_LAST, (int*)&dither, OPTIONS_DITH_TE, OPTIONS_DITH_CY);
			break;
		case OPTIONS_DITH_CY:
			do_options_popup(x_gem->event_wind, 1, adr_popup_dither, POPUP_DITH_LAST, (int*)&dither, OPTIONS_DITH_TE, OPTIONS_DITH_CY);
			break;

		case OPTIONS_BUBBLE:
			if(!(adr[OPTIONS_BUBBLE].ob_state&SELECTED))
				{
				adr[OPTIONS_TIME_CHK].ob_state |= DISABLED;
				adr[OPTIONS_TIME_TXT].ob_state |= DISABLED;
				adr[OPTIONS_MS].ob_state |= DISABLED;
				adr[OPTIONS_RIGHT].ob_state |= DISABLED;
				}
			else
				{
				adr[OPTIONS_TIME_CHK].ob_state &= ~DISABLED;
				adr[OPTIONS_TIME_TXT].ob_state &= ~DISABLED;
				adr[OPTIONS_TIME_TXT].ob_flags |= EDITABLE;
				adr[OPTIONS_MS].ob_state &= ~DISABLED;
				adr[OPTIONS_RIGHT].ob_state &= ~DISABLED;
				}
			s_objc_draw (adr, OPTIONS_BUB_BACK, MAX_DEPTH, &x_gem->desk_size);
			break;

		case OPTIONS_CACHE_BU:
			{
			char *path=NULL, text[256]={0};

			if(options.paths.cache!=NULL)
				path = options.paths.cache;
			x_file_select (1, STR (DI_OPEN), "*.*", path, text);

			while(text[strlen(text)-1]!='\\')
				text[strlen(text)-1] = 0;

			if(options.paths.cache)
				free(options.paths.cache);
			options.paths.cache = calloc(1, strlen(text)+2);
			strcpy(options.paths.cache, text);
			options.max_memory = FALSE;

			if(strlen(options.paths.cache)>29)
				{
				memset(text, 0, 256);
				strncpy(text, options.paths.cache, 10);
				strcat(text, "...");
				strcat(text, &options.paths.cache[strlen(options.paths.cache)-15]);
				x_set_ob_text(adr, OPTIONS_CACHE_PA, text);
				}
			else
				x_set_ob_text(adr, OPTIONS_CACHE_PA, options.paths.cache);
			s_objc_draw (adr, OPTIONS_CACHE_PA, MAX_DEPTH, &x_gem->desk_size);
			break;
			}
		}

	x_redraw_wind (wind_options_handle, DRAW_AES, obj, &x_gem->desk_size);
	}


void handle_options_dialog(void)
	{
	}


	/* en cas de fermeture du formulaire... */
void close_options_form (short window)
{
	window = window;							/* ce paramtre ne nous est pas utile cette fois-ci ! */
	wind_options_handle = -1;								/* indiquer que la fentre est ferme  l'aide du flag */
}


void redraw_icon_form (short wind)
{
/*	register short x, y;
	register WIND_LIST *window;

	window = &x_gem->wind[wind];

	if (! window->w_iconify)
		return;

	wind_get (window->w_hand, WF_WORKXYWH, &adr_icon->ob_x, &adr_icon->ob_y, &adr_icon->ob_width, &adr_icon->ob_height);
	x = (adr_icon->ob_width - adr_icon[MOTIF].ob_width) >> 1;
	if (x < 0)
		x = 0;
	y = (adr_icon->ob_height - adr_icon[MOTIF].ob_height) >> 1;
	if (y < 0)
		y = 0;
	adr_icon[MOTIF].ob_x = x;
	adr_icon[MOTIF].ob_y = y;

	s_objc_draw (adr_icon, ROOT, MAX_DEPTH, window->w_redraw_grect);	*/
}